package game;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import main.*;

public class GamePanel extends JPanel implements Runnable
{
	Dimension size;   // パネルの大きさ
	MainPanel mp;
	Thread td;
	boolean in_game = true;
	Hero hr;   // 主人公
	Road rd;   // 背景（道）
			// コンストラクタ
	public GamePanel(Dimension size1, MainPanel mp1)
	{
		size = size1;
		mp   = mp1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(Color.white);
					// 主人公と道の生成
		rd = new Road(size, mp);
		hr = new Hero(size, rd, mp);
					// スレッドの生成
		td = new Thread(this);
		td.start();
					// マウスリスナの追加
		addMouseListener(new Mouse());
	}
			// スレッドの実行
	public void run()
	{
		while (in_game) {
			try {
				td.sleep(30);
			}
			catch (InterruptedException e) {}
					// 移動と再描画
			hr.x += (int)hr.v_x;
			rd.x += (int)rd.v_x;
			repaint();
					// 道の状態のチェック
			int p = hr.x - rd.x + hr.width / 2, sw = -1;
			for (int i1 = 0; i1 < rd.state.length && sw < 0; i1++) {
				if (p <= rd.state[i1][0])
					sw = rd.state[i1][1];
			}
			if (sw < 0)
				sw = 1;
			if (sw > 0) {
				in_game = false;
				if (sw == 1)
					mp.state = 3;   // ゲームオーバー
				else
					mp.state = 2;   // ゲームクリア
			}
		}
	}
			// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
		g.drawImage(rd.image, rd.x, rd.y, this);
		g.drawImage(hr.image, hr.x, hr.y, this);
	}
			// マウスイベントの処理
	class Mouse extends MouseAdapter {
					// ボタンが押されたとき
		public void mousePressed(MouseEvent e) {
			in_game  = false;
			mp.state = 2;
		}
	}
}
