package game;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import main.*;

public class GamePanel extends JPanel implements Runnable
{
	Dimension size;   // パネルの大きさ
	MainPanel mp;
	Thread td;
	boolean in_game = true;
	Hero hr;   // 主人公
	Road rd;   // 背景（道）
	double up = 0;   // 上向き加速度
	double down = 0;   // 下向き加速度
	boolean jump = false;   // ジャンプ中か？
			// コンストラクタ
	public GamePanel(Dimension size1, MainPanel mp1)
	{
		size = size1;
		mp   = mp1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(Color.white);
					// 主人公と道の生成
		rd = new Road(size, mp);
		hr = new Hero(size, rd, mp);
					// スレッドの生成
		td = new Thread(this);
		td.start();
					// マウスリスナの追加
		addMouseListener(new Mouse());
	}
			// スレッドの実行
	public void run()
	{
		while (in_game) {
			try {
				td.sleep(30);
			}
			catch (InterruptedException e) {}
					// 移動と再描画
			hr.v_y += (up - down);
			hr.x   += (int)hr.v_x;
			hr.y   -= (int)hr.v_y;
			rd.x   += (int)rd.v_x;
			repaint();
					// 状態のチェック
							// 水平位置のチェック
			int p  = hr.x - rd.x + hr.width / 2, sw = -1;
			for (int i1 = 0; i1 < rd.state.length && sw < 0; i1++) {
				if (p <= rd.state[i1][0])
					sw = rd.state[i1][1];
			}
			if (sw < 0)   // ゴールを通過
				sw = 1;
							// 垂直位置のチェック
			else {
				if (jump) {
					if (hr.y >= size.height - rd.height - hr.height) {
						if (sw == 0 || sw == 10) {
							jump   = false;
							down   = 0.0;
							hr.v_x = 1.0;
							hr.v_y = 0.0;
							hr.y   = size.height - rd.height - hr.height;
						}
					}
					else
						sw = 0;
				}
			}
							// ゲーム状態変更
			if (sw > 0) {
				in_game = false;
				if (sw == 1)
					mp.state = 3;   // ゲームオーバー
				else
					mp.state = 2;   // ゲームクリア
			}
		}
	}
			// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
		g.drawImage(rd.image, rd.x, rd.y, this);
		g.drawImage(hr.image, hr.x, hr.y, this);
	}
			// マウスイベントの処理
	class Mouse extends MouseAdapter {
					// ボタンが押されたとき
		public void mousePressed(MouseEvent e) {
			if (!jump) {
				up     = 1.0;
				down   = 0.5;
				hr.v_x = 2.0;
				jump   = true;
				hr.y--;   // 着地判定のため，1 ピクセルだけジャンプさせておく
			}
		}
					// ボタンが離されたとき
		public void mouseReleased(MouseEvent e) {
			up   = 0.0;
			down = 0.5;
		}
	}
}
