import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("オブジェクトと点との衝突判定");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(640, 470);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		Dimension d  = getSize();   // Windowの大きさ
		d.width     -= 40;
		d.height    -= 70;
		MainPanel pn = new MainPanel(d);   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel implements Runnable
{
	boolean state = true;
	double x1, x2, y1, y2, t = 0.0, v = 20.0;
	double x[] = {40, 40*Math.cos(Math.PI/6), 40*Math.cos(Math.PI/3), 0, 40*Math.cos(2*Math.PI/3), 40*Math.cos(5*Math.PI/6), -40, 40*Math.cos(7*Math.PI/6), 40*Math.cos(4*Math.PI/3), 0, 40*Math.cos(5*Math.PI/3), 40*Math.cos(11*Math.PI/6)};
	double y[] = {0, 40*Math.sin(Math.PI/6), 40*Math.sin(Math.PI/3), 40, 40*Math.sin(2*Math.PI/3), 40*Math.sin(5*Math.PI/6), 0, 40*Math.sin(7*Math.PI/6), 40*Math.sin(4*Math.PI/3), -40, 40*Math.sin(5*Math.PI/3), 40*Math.sin(11*Math.PI/6)};
	Dimension d;
	Thread th;
	Ellipse2D.Double cir1, cir2;
	boolean hit = false;

	MainPanel(Dimension d1)
	{
		d = d1;
		x1 = 0.0;
		x2 = d.width - 80;
		y1 = d.height / 2 - 50;
		y2 = d.height / 2 - 80;
		cir1 = new Ellipse2D.Double(x1, y1, 80, 100);
		cir2 = new Ellipse2D.Double(x2, y2, 80, 80);
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		th = new Thread(this);   // スレッドの生成とスタート
		th.start();
	}
					// 他ページへ移動の際，一時的にスレッドを停止
	public void stop()
	{
		state = false;
	}
					// スレッドの実行
	public void run()
	{
		while (state) {
			try {
				th.sleep(33);
			}
			catch (InterruptedException e) {}
							// 衝突判定
			for (int i1 = 0; i1 < 12; i1++) {
				hit = cir1.contains(x2+40+x[i1], y2+40+y[i1]);
				if (hit)
					break;
			}
							// 移動
			if (hit)
				state = false;
			else {
				t += 0.1;
				x1 = v * t;
				x2 = d.width - 80 - v * t;
			}
			repaint();
		}
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
							// Graphics2Dの取得
		Graphics2D g2 = (Graphics2D)g;
							// 塗りつぶした楕円
		g2.setColor(Color.green);
		cir1 = new Ellipse2D.Double(x1, y1, 80, 100);
		g2.fill(cir1);
							// 塗りつぶした円
		g2.setColor(Color.red);
		cir2 = new Ellipse2D.Double(x2, y2, 80, 80);
		g2.fill(cir2);
	}
}
