import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("距離による衝突判定");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(640, 470);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		Dimension d  = getSize();   // Windowの大きさ
		d.width     -= 40;
		d.height    -= 70;
		MainPanel pn = new MainPanel(d);   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel implements Runnable
{
	boolean state = true;
	double x1, x2, y1, y2, t = 0.0, v = 20.0;
	Dimension d;
	Thread th;
	boolean hit = false;

	MainPanel(Dimension d1)
	{
		d = d1;
		x1 = 0.0;
		x2 = d.width - 80;
		y1 = d.height / 2 - 40;
		y2 = d.height / 2 - 80;
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		th = new Thread(this);   // スレッドの生成とスタート
		th.start();
	}
					// 他ページへ移動の際，一時的にスレッドを停止
	public void stop()
	{
		state = false;
	}
					// スレッドの実行
	public void run()
	{
		while (state) {
			try {
				th.sleep(33);
			}
			catch (InterruptedException e) {}
							// 衝突判定
			double x = x1 - x2;
			double y = y1 - y2;
			if (Math.sqrt(x*x+y*y) <= 80)
				hit = true;
							// 移動
			if (hit)
				state = false;
			else {
				t += 0.1;
				x1 = v * t;
				x2 = d.width - 80 - v * t;
			}

			repaint();
		}
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
							// 塗りつぶした円
		g.setColor(Color.green);
		g.fillOval((int)x1, (int)y1, 80, 80);
							// 塗りつぶした円
		g.setColor(Color.red);
		g.fillOval((int)x2, (int)y2, 80, 80);
	}
}
