import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("マウスクリック");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(310, 200);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		MainPanel pn = new MainPanel();   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
		pn.setSize(270, 130);
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel
{
	int x = 30, y = 25;

	MainPanel()
	{
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		addMouseListener(new ClickMouse());   // MouseListenerの追加
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
							// Graphics2Dの取得
		Graphics2D g2 = (Graphics2D)g;
							// 線幅が5ピクセルの矩形
		g2.setStroke(new BasicStroke(5.0f));
		g2.draw(new Rectangle(20, 15, 100, 100));
		g2.draw(new Rectangle(150, 15, 100, 100));
							// 塗りつぶされた円
		g.setColor(Color.green);
		g.fillOval(x, y, 80, 80);
	}

	/******************************/
	/* クリック押されたときの処理 */
	/******************************/
	class ClickMouse extends MouseAdapter {
		public void mouseClicked(MouseEvent e)
		{
			int x1 = e.getX();
			int y1 = e.getY();

			if (x1 < 125) {
				x1 -= 70;
				y1 -= 65;
				double r = Math.sqrt(x1 * x1 + y1 * y1);
				if (r <= 40.0) {
					x = 160;
					repaint();
				}
			}
			else {
				x1 -= 200;
				y1 -= 65;
				double r = Math.sqrt(x1 * x1 + y1 * y1);
				if (r <= 40.0) {
					x = 30;
					repaint();
				}
			}
		}
	}
}
