import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("ドラッグ");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(310, 200);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		MainPanel pn = new MainPanel();   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
		pn.setSize(270, 130);
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel implements MouseMotionListener
{
	int x = 30, y = 25, xb = 30, yb = 25, x0 = 0, y0 = 0;
	boolean drag = false;

	MainPanel()
	{
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		addMouseMotionListener(this);   // MouseMotionListenerの追加
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
							// Graphics2Dの取得
		Graphics2D g2 = (Graphics2D)g;
							// 線幅が5ピクセルの矩形
		g2.setStroke(new BasicStroke(5.0f));
		g2.draw(new Rectangle(20, 15, 100, 100));
		g2.draw(new Rectangle(150, 15, 100, 100));
							// 塗りつぶされた円
		g.setColor(Color.green);
		g.fillOval(x, y, 80, 80);
	}

	/******************************/
	/* マウスが移動したときの処理 */
	/******************************/
	public void mouseDragged(MouseEvent e)
	{
		if (!drag) {
			double x1 = e.getX() - (x + 40);
			double y1 = e.getY() - (y + 40);
			double r = Math.sqrt(x1 * x1 + y1 * y1);
			if (r <= 40.0) {
				x0 = e.getX();
				y0 = e.getY();
				drag = true;
			}
		}
		else {
			x = xb + (e.getX() - x0);
			y = yb + (e.getY() - y0);
			repaint();
		}
	}
	public void mouseMoved(MouseEvent e)
	{
		if (drag) {
			drag = false;
			xb = x;
			yb = y;
		}
	}
}
