import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("ビットマップ");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(310, 200);   // +40, +70
					// ContentPane の取得とパネルの追加と MainPanel の追加
		MainPanel pn = new MainPanel();   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
		pn.setSize(270, 130);
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel
{
	Image im;
	MainPanel()
	{
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		int pixels[] = new int [100*100];
		for (int i1 = 0; i1 < 100; i1++) {
			for (int i2 = 0; i2 < 100; i2++)
				pixels[i1*100+i2] = 0xff00ff00;
		}
		MemoryImageSource mis = new MemoryImageSource(100, 100, pixels, 0, 100);
		im = createImage(mis);
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画

		g.setColor(Color.green);
		g.fillRect(20, 15, 100, 100);

		g.drawImage(im, 150, 15, this);
	}
}
