import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.imageio.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("フィルタ（ぼかし，外部画像）");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(590, 370);   // +40, +70
					// 画像が完全に読み込まれるまで待つ
		Image im = getToolkit().getImage("hana.gif");
		MediaTracker trk = new MediaTracker(this);
		trk.addImage(im, 0);
		try {
			trk.waitForID(0);
		}
		catch (InterruptedException e) {}
					// ContentPane の取得と MainPanel の追加
		MainPanel pn = new MainPanel(im);   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
		pn.setSize(550, 300);
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel
{
	Image im1;
	BufferedImage im2;
	MainPanel(Image im)
	{
		im1 = im;
		setBackground(Color.white);   // 背景色の設定
					// BufferedImageに変換
		int w = im1.getWidth(null);
		int h = im1.getHeight(null);
		BufferedImage im0 = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);
		Graphics g = im0.getGraphics();
		g.drawImage(im1, 0, 0, null);
		g.dispose();
					// フィルタ（ぼかし）
		ConvolveOp c = new ConvolveOp(new Kernel(7, 7,
			new float[] {
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f
			}), ConvolveOp.EDGE_NO_OP, null);
		im2 = c.filter(im0, im2);
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画

		g.drawImage(im1, 50, 50, this);

		g.drawImage((Image)im2, 300, 50, this);
	}
}
