import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.imageio.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("フィルタ（ぼかし）");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(310, 200);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		MainPanel pn = new MainPanel();   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
		pn.setSize(270, 130);
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel
{
	BufferedImage im2;
	MainPanel()
	{
		setBackground(new Color(238, 255, 238));   // 背景色の設定
					// BufferedImageの生成
		int w = 100;
		int h = 100;
		BufferedImage im0 = new BufferedImage(110, 110, BufferedImage.TYPE_INT_RGB);
		Graphics g = im0.getGraphics();
		g.setColor(new Color(238, 255, 238));
		g.fillRect(0, 0, 110, 110);
		g.setColor(Color.blue);
		g.fillRect(5, 5, 100, 100);
		g.dispose();   // グラフィックスコンテキストを破棄
					// フィルタ（ぼかし）
		ConvolveOp c = new ConvolveOp(new Kernel(7, 7,
			new float[] {
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f,
				1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f, 1/49f
			}), ConvolveOp.EDGE_NO_OP, null);
		im2 = c.filter(im0, im2);
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画

		g.setColor(Color.blue);
		g.fillRect(20, 15, 100, 100);

		g.drawImage((Image)im2, 150, 10, this);
	}
}
