import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("背景（マップ）１");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(440, 370);   // +40, +70
					// 画像の読み込み
		Image im[] = new Image [2];   // 画像ファイル
		im[0] = getToolkit().getImage("obj1.jpg");   // イメージの読み込み
		im[1] = getToolkit().getImage("obj2.jpg");   // イメージの読み込み
					// ContentPane の取得と MainPanel の追加
		Dimension d  = getSize();   // Windowの大きさ
		d.width     -= 40;
		d.height    -= 70;
		MainPanel pn = new MainPanel(d, im);   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel implements Runnable
{
	Thread td;
	Map mp;   // 背景（マップ）
	Dimension size;
	Image im[];
	boolean state = true;
			// コンストラクタ
	public MainPanel(Dimension d, Image im1[])
	{
		size = d;
		im = im1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(Color.white);
					// 背景の生成
		mp = new Map();
					// スレッドの生成
		td = new Thread(this);
		td.start();
	}
			// スレッドの実行
	public void run()
	{
		while (state) {
			try {
				td.sleep(30);
			}
			catch (InterruptedException e) {}
			mp.x += (int)mp.v_x;
			repaint();
		}
	}
			// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
					// 背景の描画
		for (int i1 = 0; i1 < mp.col; i1++) {
			int x = mp.x + mp.width * i1;
			if (x + mp.width >= 0 && x <= size.width) {
				for (int i2 = 0; i2 < mp.row; i2++) {
					if (mp.map[i2][i1] > 0) {
						int y = i2 * mp.height;
						g.drawImage(im[mp.map[i2][i1]-1], x, y, this);
					}
				}
			}
		}
	}
}
