import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("跳ね返り");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(640, 470);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		Dimension d  = getSize();   // Windowの大きさ
		d.width     -= 40;
		d.height    -= 70;
		MainPanel pn = new MainPanel(d);   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel implements Runnable
{
	boolean state = true;
	double x1, x2, y1, y2, vx1 = 50, vy1 = 55, vx2 = 50, vy2 = 55, dt = 0.1;
	int width = 40;
	Dimension d;
	Thread th;

	MainPanel(Dimension d1)
	{
		d = d1;
		x1 = width / 2;
		y1 = width / 2;
		x2 = x1;
		y2 = y1;
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		th = new Thread(this);   // スレッドの生成とスタート
		th.start();
	}
					// 他ページへ移動の際，一時的にスレッドを停止
	public void stop()
	{
		state = false;
	}
					// スレッドの実行
	public void run()
	{
		while (state) {
			try {
				th.sleep(33);
			}
			catch (InterruptedException e) {}
							// 摩擦なし（緑）
			if (y1 + width / 2 > d.height) {
				vy1 *= -1.0;
				y1   = d.height - width / 2;   // 位置の修正
			}
			else if (y1 - width / 2 < 0) {
				vy1 *= -1.0;
				y1   = width / 2;   // 位置の修正
			}
			else if (x1 + width / 2 > d.width) {
				vx1 *= -1.0;
				x1   = d.width - width / 2;   // 位置の修正
			}
			else if (x1 - width / 2 < 0) {
				vx1 *= -1.0;
				x1   = width / 2;   // 位置の修正
			}
			x1 += vx1 * dt;
			y1 += vy1 * dt;
							// 摩擦あり（赤）
			if (y2 + width / 2 > d.height) {
				vx2 *= 0.8;
				vy2 *= -0.8;
				y2   = d.height - width / 2;   // 位置の修正
			}
			else if (y2 - width / 2 < 0) {
				vx2 *= 0.8;
				vy2 *= -0.8;
				y2   = width / 2;   // 位置の修正
			}
			else if (x2 + width / 2 > d.width) {
				vx2 *= -0.8;
				vy2 *= 0.8;
				x2   = d.width - width / 2;   // 位置の修正
			}
			else if (x2 - width / 2 < 0) {
				vx2 *= -0.8;
				vy2 *= 0.8;
				x2   = width / 2;   // 位置の修正
			}
			x2 += vx2 * dt;
			y2 += vy2 * dt;

			repaint();
		}
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画

		g.setColor(Color.green);
		g.fillOval((int)x1-20, (int)y1-20, 40, 40);
		g.setColor(Color.red);
		g.fillOval((int)x2-20, (int)y2-20, 40, 40);
	}
}
