import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Random;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("乱数");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(640, 470);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		Dimension d  = getSize();   // Windowの大きさ
		d.width     -= 40;
		d.height    -= 70;
		MainPanel pn = new MainPanel(d);   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel implements Runnable
{
	boolean state = true;
	double x, y, vx, vy, a, dt = 0.1;
	int width = 40;
	Random rn;
	Dimension d;
	Thread th;

	MainPanel(Dimension d1)
	{
		d = d1;
		rn = new Random();
		x  = width / 2 + rn.nextDouble() * (d.width - width);
		y  = width / 2;
		a  = rn.nextDouble() * Math.PI;
		vx = 70 * Math.cos(a);
		vy = 70 * Math.sin(a);
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		th = new Thread(this);   // スレッドの生成とスタート
		th.start();
	}
					// 他ページへ移動の際，一時的にスレッドを停止
	public void stop()
	{
		state = false;
	}
					// スレッドの実行
	public void run()
	{
		while (state) {
			try {
				th.sleep(33);
			}
			catch (InterruptedException e) {}

			if (y + width / 2 > d.height) {
				a  = rn.nextDouble() * Math.PI;
				vx = 70 * Math.cos(a);
				vy = -70 * Math.sin(a);
				y  = d.height - width / 2;   // 位置の修正
			}
			else if (y - width / 2 < 0) {
				a  = rn.nextDouble() * Math.PI;
				vx = 70 * Math.cos(a);
				vy = 70 * Math.sin(a);
				y  = width / 2;   // 位置の修正
			}
			else if (x + width / 2 > d.width) {
				a  = rn.nextDouble() * Math.PI - 0.5 * Math.PI;
				vx = -70 * Math.cos(a);
				vy = 70 * Math.sin(a);
				x  = d.width - width / 2;   // 位置の修正
			}
			else if (x - width / 2 < 0) {
				a  = rn.nextDouble() * Math.PI - 0.5 * Math.PI;
				vx = 70 * Math.cos(a);
				vy = 70 * Math.sin(a);
				x  = width / 2;   // 位置の修正
			}
			x += vx * dt;
			y += vy * dt;

			repaint();
		}
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画

		g.setColor(Color.green);
		g.fillOval((int)x-20, (int)y-20, 40, 40);
	}
}
