import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("アフィン変換２");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(340, 320);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		MainPanel pn = new MainPanel();   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
		pn.setSize(300, 250);
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel
{
	MainPanel()
	{
		setBackground(new Color(238, 255, 238));   // 背景色の設定
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
							// Graphics2Dの取得
		Graphics2D g2 = (Graphics2D)g;
							// 線幅が5ピクセルの矩形（左上）
		g2.setStroke(new BasicStroke(5.0f));
		g2.draw(new Rectangle(20, 20, 100, 50));
							// 塗りつぶした矩形（赤）（左中）
		g2.setColor(Color.red);
		g2.fill(new Rectangle(20, 90, 100, 50));
							// 塗りつぶした矩形（グラデーション）（左下）
		g2.setPaint(new GradientPaint(20f, 160f, Color.yellow, 120f, 160f, Color.red));
		g2.fill(new Rectangle(20, 160, 100, 50));
							// 移動（右上）
		g2.setColor(Color.green);
		g2.setStroke(new BasicStroke(5.0f));
		g2.transform(new AffineTransform());
		g2.translate(140.0, 0.0);
		g2.draw(new Rectangle(20, 20, 100, 50));
							// 回転（右中）
		g2.translate(30, 70);
		g2.rotate(45.0 * Math.PI / 180.0);
		g2.draw(new Rectangle(30, 0, 100, 50));
							// 縮小（右下）
		g2.rotate(-45.0 * Math.PI / 180.0);
		g2.scale(0.7, 0.7);
		g2.draw(new Rectangle(0, 150, 100, 50));
	}
}
