import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("アフィン変換３");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(310, 220);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		MainPanel pn = new MainPanel();   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
		pn.setSize(270, 150);
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel
{
	private int state = 0;   //マウスによるクリック状態

	MainPanel()
	{
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		addMouseListener(new ClickMouse());
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
							// Graphics2Dの取得
		Graphics2D g2 = (Graphics2D)g;
		g2.setColor(Color.green);
		g2.setStroke(new BasicStroke(5.0f));
							// 線幅が5ピクセルの矩形
		if (state % 2 == 0)
			g2.draw(new Rectangle(20, 20, 100, 50));
							// 拡大と移動
		else {
			g2.transform(new AffineTransform());
			g2.translate(70.0, 30.0);
			g2.scale(1.5, 1.5);
			g2.draw(new Rectangle(20, 20, 100, 50));
		}
	}
	/******************************/
	/* クリック押されたときの処理 */
	/******************************/
	class ClickMouse extends MouseAdapter {
		public void mouseClicked(MouseEvent e)
		{
			state++;
			repaint();
		}
	}
}
