import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("自由落下");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(640, 470);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		Dimension d  = getSize();   // Windowの大きさ
		d.width     -= 40;
		d.height    -= 70;
		MainPanel pn = new MainPanel(d);   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel implements Runnable
{
	boolean state = true;
	double x, y, x0 = 0.0, y0, t = 0.0, dt = 0.04, vx0 = 100.0, vy0 = -200.0, vy, g = 98.0;
	Dimension d;
	Thread th;

	MainPanel(Dimension d1)
	{
		d  = d1;
		y0 = d.height / 2;
		x  = x0;
		y  = y0;
		vy = vy0;
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		th = new Thread(this);   // スレッドの生成とスタート
		th.start();
	}
					// 他ページへ移動の際，一時的にスレッドを停止
	public void stop()
	{
		state = false;
	}
					// スレッドの実行
	public void run()
	{
		while (state) {
			try {
				th.sleep(40);
			}
			catch (InterruptedException e) {}
			if (x < d.width && y < d.height) {
				t += dt;
				x  = vx0 * t;   // この行と次の行の代わりに，それ以降の5行でも良い
				y  = y0 + vy0 * t + 0.5 * g * t * t;
//				x += vx0 * dt;
//				double v1 = vy;
//				double v2 = vy + g * dt;
//				y += 0.5 * (v1 + v2) * dt;
//				vy = v2;
			}
			else {
				x  = x0;
				y  = y0;
				vy = vy0;
				t  = 0;
			};
			repaint();
		}
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画

		g.setColor(Color.green);
		g.fillOval((int)x-20, (int)y-20, 40, 40);
	}
}
