import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Test {
	public static void main (String[] args)
	{
		Win win = new Win("摩擦２");
	}
}

class Win extends JFrame
{
	/******************/
	/* コンストラクタ */
	/******************/
	Win(String name)
	{
					// JFrameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
					// Windowの大きさ
		setSize(640, 470);   // +40, +70
					// ContentPane の取得と MainPanel の追加
		Dimension d  = getSize();   // Windowの大きさ
		d.width     -= 40;
		d.height    -= 70;
		MainPanel pn = new MainPanel(d);   // MainPanel オブジェクトの生成
		getContentPane().add(pn);   // MainPanel オブジェクトを ContentPane に追加
					// ウィンドウを表示
		setVisible(true);
					// イベントアダプタ
		addWindowListener(new WinEnd());
	}

	/******************************/
	/* 上，左，下，右の余白の設定 */
	/******************************/
	public Insets getInsets()
	{
		return new Insets(50, 20, 20, 20);
	}

	/************/
	/* 終了処理 */
	/************/
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
	}
}

class MainPanel extends JPanel implements Runnable
{
	boolean state = true;
	double x0, y0, x1, x2, y1, y2, dt = 0.04;
	double vx0 = 100.0, vy0 = -200.0, vy, vx_f, vy_f, g = 98.0, k = 0.2, m = 1.0;
	Dimension d;
	Thread th;

	MainPanel(Dimension d1)
	{
		d = d1;
		x0 = 0.0;
		y0 = d.height / 2;
		x1 = x0;   // 摩擦が無い場合
		y1 = y0;
		vy = vy0;
		x2 = x0;   // 摩擦がある場合
		y2 = y0;
		vx_f = vx0;
		vy_f = vy0;
		setBackground(new Color(238, 255, 238));   // 背景色の設定
		th = new Thread(this);   // スレッドの生成とスタート
		th.start();
	}
					// 他ページへ移動の際，一時的にスレッドを停止
	public void stop()
	{
		state = false;
	}
					// スレッドの実行
	public void run()
	{
		while (state) {
			try {
				th.sleep(40);
			}
			catch (InterruptedException e) {}
			if (x1 < d.width && y1 < d.height) {
					// 摩擦無し
				x1 += vx0 * dt;
				double v1 = vy;
				double v2 = vy + g * dt;
				y1 += 0.5 * (v1 + v2) * dt;
				vy = v2;
					// 摩擦あり
				v1 = vx_f;
				v2 = vx_f + (-k * vx_f / m) * dt;
				x2 += 0.5 * (v1 + v2) * dt;
				vx_f = v2;

				v1 = vy_f;
				v2 = vy_f + (-k * vy_f / m + g) * dt;
				y2 += 0.5 * (v1 + v2) * dt;
				vy_f = v2;
			}
			else {
				x1   = x0;
				y1   = y0;
				x2   = x0;
				y2   = y0;
				vy   = vy0;
				vx_f = vx0;
				vy_f = vy0;
			};
			repaint();
		}
	}
					// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画

		g.setColor(Color.green);
		g.fillOval((int)x1-20, (int)y1-20, 40, 40);
		g.setColor(Color.red);
		g.fillOval((int)x2-20, (int)y2-20, 40, 40);
	}
}
