package game;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import main.*;

public class Operation extends JPanel implements ActionListener
{
	MainPanel mp;
	Maze mz;
	JButton left, right, up, down;
			// コンストラクタ
	public Operation(int width, int height, MainPanel mp1, Maze mz1)
	{
		mp = mp1;
		mz = mz1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(Color.white);
					// ボタンの配置
		Font f = new Font("SansSerif", Font.BOLD, 12);
		FontMetrics fm = getFontMetrics(f);

		String str1 = "左";
		int w1 = fm.stringWidth(str1) + 40;
		int h1 = fm.getHeight() + 10;
		left = new JButton(str1);
		left.setFont(f);
		left.addActionListener(this);   // アクションリスナ
		left.setSize(w1, h1);

		String str2 = "右";
		int w2 = fm.stringWidth(str2) + 40;
		int h2 = fm.getHeight() + 10;
		right = new JButton(str2);
		right.setFont(f);
		right.addActionListener(this);   // アクションリスナ
		right.setSize(w2, h2);

		String str3 = "上";
		int w3 = fm.stringWidth(str3) + 40;
		int h3 = fm.getHeight() + 10;
		up = new JButton(str3);
		up.setFont(f);
		up.addActionListener(this);   // アクションリスナ
		up.setSize(w3, h3);

		String str4 = "下";
		int w4 = fm.stringWidth(str4) + 40;
		int h4 = fm.getHeight() + 10;
		down = new JButton(str4);
		down.setFont(f);
		down.addActionListener(this);   // アクションリスナ
		down.setSize(w4, h4);

		int w = w1 + w2 + 5;
		left.setLocation(width/2-w/2, height/2-h1/2);
		add(left);
		right.setLocation(width/2-w/2+w1+5, height/2-h1/2);
		add(right);
		up.setLocation(width/2-w3/2, height/2-h1/2-h3-5);
		add(up);
		down.setLocation(width/2-w4/2, height/2+h1/2+5);
		add(down);

		check();   // ボタンの有効性のチェック
	}
			// ボタンがクリックされたときの処理
	public void actionPerformed(ActionEvent e)
	{
					// 移動
		if (e.getSource() == left) {
			mz.hr.x--;
			mz.x++;
		}
		else if (e.getSource() == right) {
			mz.hr.x++;
			mz.x--;
		}
		else if (e.getSource() == up) {
			mz.hr.y--;
			mz.y++;
		}
		else {
			mz.hr.y++;
			mz.y--;
		}
					// ゲームクリア？
		if (mz.hr.x < 0 || mz.hr.x >= mz.width || mz.hr.y < 0 || mz.hr.y >= mz.height)
			mp.state = 2;
					// ボタンの設定
		else {
			left.setEnabled(true);
			right.setEnabled(true);
			up.setEnabled(true);
			down.setEnabled(true);
			check();   // ボタンの有効性のチェック
		}
					// 再描画
		mz.repaint();
	}
			// ボタンの有効性のチェック
	void check()
	{
		if (mz.hr.x > 0 && mz.map[mz.hr.y][mz.hr.x-1] > 0)
			left.setEnabled(false);
		if (mz.hr.x < mz.width-1 && mz.map[mz.hr.y][mz.hr.x+1] > 0)
			right.setEnabled(false);
		if (mz.hr.y > 0 && mz.map[mz.hr.y-1][mz.hr.x] > 0)
			up.setEnabled(false);
		if (mz.hr.y < mz.height-1 && mz.map[mz.hr.y+1][mz.hr.x] > 0)
			down.setEnabled(false);
	}
}
