package start;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class Problem extends JFrame implements ActionListener
{
	int pr[][] = new int[9][9];
	JTextField tx[][] = new JTextField[9][9];
	JButton bt1, bt2, bt3;
	JTextField sp;
	Bord bd[];
	Random rn;
			// 初期設定
	Problem(String name, Bord bd1[])
	{
					// Frameクラスのコンストラクタ（Windowのタイトルを引き渡す）
		super(name);
		bd = bd1;
					// Windowの大きさ
		setSize(400, 400);
					// 背景色の設定，レイアウト，フォント
		setBackground(new Color(220, 255, 220));   // 背景色
		setLayout(new BorderLayout(5, 5));
		Font f = new Font("SansSerif", Font.BOLD, 20);
					// 乱数
		rn = new Random();
					// 上のパネル
		JPanel jp1 = new JPanel();
		jp1.setBackground(new Color(220, 255, 220));
		add(jp1, BorderLayout.NORTH);;

		bt1 = new JButton("解");
		bt1.setFont(f);
		bt1.addActionListener(this);
		jp1.add(bt1);

		JLabel lb2 = new JLabel("　");
		lb2.setFont(f);
		jp1.add(lb2);

		JLabel lb1 = new JLabel("空白");
		lb1.setFont(f);
		jp1.add(lb1);

		sp = new JTextField(2);
		sp.setFont(f);
		jp1.add(sp);

		bt2 = new JButton("Go");
		bt2.setFont(f);
		bt2.addActionListener(this);
		jp1.add(bt2);

		JLabel lb3 = new JLabel("　");
		lb3.setFont(f);
		jp1.add(lb3);

		bt3 = new JButton("設定");
		bt3.setFont(f);
		bt3.addActionListener(this);
		jp1.add(bt3);
					// 下のパネル
		JPanel jp2 = new JPanel();
		add(jp2, BorderLayout.CENTER);;
		jp2.setLayout(new GridLayout(9, 9, 5, 5));
		jp2.setBackground(new Color(220, 255, 220));
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 9; i2++) {
				tx[i1][i2] = new JTextField(1);
				tx[i1][i2].setFont(f);
				jp2.add(tx[i1][i2]);
			}
		}
					// ウィンドウを表示
		setVisible(true);
					// 問題の作成
		create();
	}
			// ボタンがクリックされたときの処理
	public void actionPerformed(ActionEvent e)
	{
					// 解
		if (e.getSource() == bt1)
			create();
					// Go
		else if (e.getSource() == bt2)
			space();
					// 設定
		else if (e.getSource() == bt3) {
			set();
			setVisible(false);
		}
	}
			// 問題の作成
	void create()
	{
					// 初期設定
		int ct1 = 0, ct2 = 0, n1 = 1, n2 = 1, ft = 1;
							// ct1 : バックトラック回数
							// ct2 : バックトラック回数の合計
							// n1 : 配置する数字
							// n2 : その数字の何個目かを示す
							// ft : 一番最初の数字（ =1 ）か否か（ =0 ）
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 9; i2++)
				pr[i1][i2] = 0;
		}
		ArrayList <Pos> mp = new ArrayList <Pos> ();
					// 設定
		while (n1 <= 9) {
			while (n2 <= 9) {
							// 最初の数字
				if (ft > 0) {
					ft    = 0;
					int k = (int)(rn.nextDouble() * 81);
					if (k >= 81)
						k = 80;
					int k1     = k / 9;
					int k2     = k % 9;
					pr[k1][k2] = 1;
					ArrayList <Integer> row1 = new ArrayList <Integer> ();
					ArrayList <Integer> col1 = new ArrayList <Integer> ();
					for (int i1 = 0; i1 < 9; i1++) {
						for (int i2 = 0; i2 < 9; i2++) {
							if (i1 != k1 || i2 != k2) {
								row1.add(i1);
								col1.add(i2);
							}
						}
					}
					Pos ps = new Pos(k1, k2, 1, 1, row1, col1);
					mp.add(ps);
					n2++;
				}
							// 2番目以降の数字
				else {
					int p[][] = new int[9][9];
					select(n1, pr, p);
					ArrayList <Integer> row1 = new ArrayList <Integer> ();
					ArrayList <Integer> col1 = new ArrayList <Integer> ();
					for (int i1 = 0; i1 < 9; i1++) {
						for (int i2 = 0; i2 < 9; i2++) {
							if (p[i1][i2] > 0) {
								row1.add(i1);
								col1.add(i2);
							}
						}
					}
									// 設定する場所がある場合
					if (row1.size() > 0) {
						int k = (int)(rn.nextDouble() * row1.size());
						if (k >= row1.size())
							k = row1.size() - 1;
						int k1     = ((Integer)row1.get(k)).intValue();
						int k2     = ((Integer)col1.get(k)).intValue();
						pr[k1][k2] = n1;
						row1.remove(k);
						col1.remove(k);
						Pos ps = new Pos(k1, k2, n1, n2, row1, col1);
						mp.add(ps);
						n2++;
					}
									// 設定する場所がない場合
					else {
						int sw = 0;
						while (sw == 0 && ct1 < 1000) {
							ct1++;
							int n = mp.size() - 1;
							if (n < 0)
								break;
							else {
								Pos ps     = mp.get(n);
								int k1     = ps.r;
								int k2     = ps.c;
								pr[k1][k2] = 0;
								mp.remove(n);
								if (ps.row.size() > 0) {
									sw    = 1;
									n1    = ps.n1;
									n2    = ps.n2;
									row1  = ps.row;
									col1  = ps.col;
									int k = (int)(rn.nextDouble() * row1.size());
									if (k >= row1.size())
										k = row1.size() - 1;
									k1         = ((Integer)row1.get(k)).intValue();
									k2         = ((Integer)col1.get(k)).intValue();
									pr[k1][k2] = n1;
									row1.remove(k);
									col1.remove(k);
									ps = new Pos(k1, k2, n1, n2, row1, col1);
									mp.add(ps);
									n2++;
								}
							}
						}
						if (sw == 0) {
							ct2 += ct1;
							ct1  = 0;
							n1   = 0;
							n2   = 10;
							ft   = 1;
							mp.clear();
							for (int i1 = 0; i1 < 9; i1++) {
								for (int i2 = 0; i2 < 9; i2++)
									pr[i1][i2] = 0;
							}
						}
					}
				}
			}
			n1++;
			n2 = 1;
		}
					// 出力
		ct2 += ct1;
		System.out.println("result " + ct2);
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 9; i2++)
				tx[i1][i2].setText(Integer.toString(pr[i1][i2]));
		}
	}
			// 数字を配置できる場所の特定
			//   n : 数字
			//   pr[i][j] : 現在の状態
			//   p[i][j] : =0 : 配置不可能
			//             =1 : 配置可能
	void select(int n, int pr[][], int p[][])
	{
					// 初期設定
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 9; i2++) {
				if (pr[i1][i2] == 0)
					p[i1][i2] = 1;
				else
					p[i1][i2] = 0;
			}
		}
					// ブロック内
		for (int i1 = 0; i1 < 9; i1++) {
			int k1 = i1 / 3 * 3;
			int k2 = (i1 % 3) * 3;
			int sw = 0;
			for (int i2 = k1; i2 < k1+3 && sw == 0; i2++) {
				for (int i3 = k2; i3 < k2+3 && sw == 0; i3++) {
					if (pr[i2][i3] == n)
						sw = 1;
				}
			}
			if (sw > 0) {
				for (int i2 = k1; i2 < k1+3; i2++) {
					for (int i3 = k2; i3 < k2+3; i3++)
						p[i2][i3] = 0;
				}
			}
		}
					// 行内
		for (int i1 = 0; i1 < 9; i1++) {
			int sw = 0;
			for (int i2 = 0; i2 < 9 && sw == 0; i2++) {
				if (pr[i1][i2] == n)
					sw = 1;
			}
			if (sw > 0) {
				for (int i2 = 0; i2 < 9; i2++)
					p[i1][i2] = 0;
			}
		}
					// 列内
		for (int i1 = 0; i1 < 9; i1++) {
			int sw = 0;
			for (int i2 = 0; i2 < 9 && sw == 0; i2++) {
				if (pr[i2][i1] == n)
					sw = 1;
			}
			if (sw > 0) {
				for (int i2 = 0; i2 < 9; i2++)
					p[i2][i1] = 0;
			}
		}
	}
			// 空白の生成
	void space()
	{
		int n = (sp.getText().length() > 0) ? Integer.parseInt(sp.getText()) : 0;
		if (n > 0) {
			int k = 0;
			while (k < n) {
				int k1 = (int)(9 * rn.nextDouble());
				if (k1 > 8)
					k1 = 8;
				int k2 = (int)(9 * rn.nextDouble());
				if (k2 > 8)
					k2 = 8;
				if (pr[k1][k2] != 0) {
					tx[k1][k2].setText("");
					pr[k1][k2] = 0;
					k++;
				}
			}
		}
	}
			// 問題の設定
	void set()
	{
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++) {
					int k1 = (i1 / 3) * 3 + i2;
					int k2 = (i1 % 3) * 3 + i3;
					bd[i1].tx[i2][i3].setText(tx[k1][k2].getText());
				}
			}
		}
	}
}

class Pos
{
	int r, c;   // 設定した場所
	int n1;   // 数字
	int n2;   // 何個目の数字か
	ArrayList <Integer> row = new ArrayList <Integer> ();   // 設定可能場所（行）
	ArrayList <Integer> col = new ArrayList <Integer> ();   // 設定可能場所（列）

	Pos(int r1, int c1, int m1, int m2, ArrayList <Integer> row1, ArrayList <Integer> col1)
	{
		r   = r1;
		c   = c1;
		n1  = m1;
		n2  = m2;
		row = row1;
		col = col1;
	}
}
