package game;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import main.*;

public class GamePanel extends JPanel implements ActionListener
{
	MainPanel mp;
	Bord bd[] = new Bord [9];
	JButton next, end;
			//
			// コンストラクタ
			//
	public GamePanel(Dimension size, MainPanel mp1)
	{
		mp = mp1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(new Color(220, 255, 220));   // 背景色
					// パネルの配置
		JPanel jp = new JPanel();
		jp.setSize(size.width, size.width);
		jp.setLocation(0, 0);
		jp.setBackground(Color.green);
		add(jp);
							// グリッドレイアウト
		jp.setLayout(new GridLayout(3, 3, 5, 5));
							// ボードの配置
		for (int i1 = 0; i1 < 9; i1++) {
			bd[i1] = new Bord(i1, mp);
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++)
					bd[i1].tx[i2][i3].addActionListener(this);
			}
			jp.add(bd[i1]);
		}
					// 「次の問題」ボタンの配置
		Font f = new Font("SansSerif", Font.BOLD, 20);
		next = new JButton("次の問題");
		next.setFont(f);
		next.setSize(120, 40);
		next.setLocation(140, 530);
		next.addActionListener(this);
		add(next);
					// 「終了」ボタンの配置
		end = new JButton("終了");
		end.setFont(f);
		end.setSize(80, 40);
		end.setLocation(280, 530);
		end.addActionListener(this);
		add(end);
	}
			//
			// ボタンがクリックされたときの処理
			//
	public void actionPerformed(ActionEvent e)
	{
					// 「終了」ボタン
		if (e.getSource() == end)
			mp.state = 2;
					// 「次の問題」ボタン
		else if (e.getSource() == next)
			mp.state = 0;
					// 数字が入力されたとき
		else {
			int k;
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 3; i2++) {
					for (int i3 = 0; i3 < 3; i3++) {
						String str = bd[i1].tx[i2][i3].getText();
						if (str.length() > 0) {
							try {
								k = Integer.parseInt(str);
								if (k == 0)
									k = -1;
							}
							catch (NumberFormatException ne)
							{
								k = -1;
							}
						}
						else
							k = 0;
						mp.pr[i1][i2][i3] = k;
					}
				}
			}
			boolean sw = check();
		}
	}
			//
			// データは適切か？
			//
	boolean check()
	{
		boolean sw = true;
					// 数字の適切性
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++) {
					bd[i1].tx[i2][i3].setForeground(Color.black);
					if (mp.pr[i1][i2][i3] < 0 || mp.pr[i1][i2][i3] > 9) {
						sw = false;
						bd[i1].tx[i2][i3].setForeground(Color.red);
					}
				}
			}
		}
					// ブロック内
		if (sw) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 8; i2++) {
					int k1 = mp.pr[i1][i2/3][i2%3];
					if (k1 > 0) {
						for (int i3 = i2+1; i3 < 9; i3++) {
							int k2 = mp.pr[i1][i3/3][i3%3];
							if (k1 == k2) {
								sw = false;
								bd[i1].tx[i2/3][i2%3].setForeground(Color.red);
								bd[i1].tx[i3/3][i3%3].setForeground(Color.red);
							}
						}
					}
				}
			}
		}
					// 行内
		if (sw) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 8; i2++) {
					int k1 = mp.pr[i1/3*3+i2/3][i1%3][i2%3];
					if (k1 > 0) {
						for (int i3 = i2+1; i3 < 9; i3++) {
							int k2 = mp.pr[i1/3*3+i3/3][i1%3][i3%3];
							if (k1 == k2) {
								sw = false;
								bd[i1/3*3+i2/3].tx[i1%3][i2%3].setForeground(Color.red);
								bd[i1/3*3+i3/3].tx[i1%3][i3%3].setForeground(Color.red);
							}
						}
					}
				}
			}
		}
					// 列内
		if (sw) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 8; i2++) {
					int k1 = mp.pr[i1/3+i2/3*3][i2%3][i1%3];
					if (k1 > 0) {
						for (int i3 = i2+1; i3 < 9; i3++) {
							int k2 = mp.pr[i1/3+i3/3*3][i3%3][i1%3];
							if (k1 == k2) {
								sw = false;
								bd[i1/3+i2/3*3].tx[i2%3][i1%3].setForeground(Color.red);
								bd[i1/3+i3/3*3].tx[i3%3][i1%3].setForeground(Color.red);
							}
						}
					}
				}
			}
		}

		return sw;
	}
}
