package start;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import main.*;

public class StartPanel extends JPanel implements ActionListener
{
	Bord bd[] = new Bord [9];
	Dimension size;   // パネルの大きさ
	MainPanel mp;
	JButton bt1, bt2, bt3;
			//
			// コンストラクタ
			//
	public StartPanel(Dimension size1, MainPanel mp1)
	{
		size = size1;
		mp   = mp1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(new Color(220, 255, 220));   // 背景色
					// パネルの配置
		JPanel jp = new JPanel();
		jp.setSize(size.width, size.width);
		jp.setLocation(0, 0);
		jp.setBackground(Color.green);
		add(jp);
							// グリッドレイアウト
		jp.setLayout(new GridLayout(3, 3, 5, 5));
							// ボードの配置
		for (int i1 = 0; i1 < 9; i1++) {
			bd[i1] = new Bord();
			jp.add(bd[i1]);
		}
					// ボタンの配置
		Font f = new Font("SansSerif", Font.BOLD, 20);
		bt1 = new JButton("遊び方");
		bt1.setFont(f);
		bt1.setSize(120, 40);
		bt1.setLocation(140, 530);
		bt1.addActionListener(this);
		add(bt1);

		bt2 = new JButton("実行");
		bt2.setFont(f);
		bt2.setSize(80, 40);
		bt2.setLocation(290, 530);
		bt2.addActionListener(this);
		add(bt2);

		bt3 = new JButton("問題");
		bt3.setFont(f);
		bt3.setSize(80, 40);
		bt3.setLocation(400, 530);
		bt3.addActionListener(this);
		add(bt3);
	}
			//
			// ボタンがクリックされたときの処理
			//
	public void actionPerformed(ActionEvent e)
	{
					// 遊び方
		if (e.getSource() == bt1) {
			Method db = new Method();
			db.setVisible(true);
			requestFocusInWindow();
		}
					// 実行
		else if (e.getSource() == bt2) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 3; i2++) {
					for (int i3 = 0; i3 < 3; i3++) {
						String str = bd[i1].tx[i2][i3].getText();
						if (str.length() > 0) {
							int k;
							try {
								k = Integer.parseInt(str);
								if (k == 0)
									k = -1;
							}
							catch (NumberFormatException ne)
							{
								k = -1;
							}
							mp.pr[i1][i2][i3] = k;
							mp.wk[i1][i2][i3] = 1;
						}
						else {
							mp.pr[i1][i2][i3] = 0;
							mp.wk[i1][i2][i3] = 0;
						}
					}
				}
			}
			boolean sw = check();
			if (sw)
				mp.state = 1;
		}
					// 問題
		else {
			Problem win = new Problem("問題作成", bd);
		}
	}
			//
			// データは適切か？
			//
	boolean check()
	{
		boolean sw = true;
					// 数字の適切性
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++) {
					bd[i1].tx[i2][i3].setForeground(Color.black);
					if (mp.pr[i1][i2][i3] < 0 || mp.pr[i1][i2][i3] > 9) {
						sw = false;
						bd[i1].tx[i2][i3].setForeground(Color.red);
					}
				}
			}
		}
					// ブロック内
		if (sw) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 8; i2++) {
					int k1 = mp.pr[i1][i2/3][i2%3];
					if (k1 > 0) {
						for (int i3 = i2+1; i3 < 9; i3++) {
							int k2 = mp.pr[i1][i3/3][i3%3];
							if (k1 == k2) {
								sw = false;
								bd[i1].tx[i2/3][i2%3].setForeground(Color.red);
								bd[i1].tx[i3/3][i3%3].setForeground(Color.red);
							}
						}
					}
				}
			}
		}
					// 行内
		if (sw) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 8; i2++) {
					int k1 = mp.pr[i1/3*3+i2/3][i1%3][i2%3];
					if (k1 > 0) {
						for (int i3 = i2+1; i3 < 9; i3++) {
							int k2 = mp.pr[i1/3*3+i3/3][i1%3][i3%3];
							if (k1 == k2) {
								sw = false;
								bd[i1/3*3+i2/3].tx[i1%3][i2%3].setForeground(Color.red);
								bd[i1/3*3+i3/3].tx[i1%3][i3%3].setForeground(Color.red);
							}
						}
					}
				}
			}
		}
					// 列内
		if (sw) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 8; i2++) {
					int k1 = mp.pr[i1/3+i2/3*3][i2%3][i1%3];
					if (k1 > 0) {
						for (int i3 = i2+1; i3 < 9; i3++) {
							int k2 = mp.pr[i1/3+i3/3*3][i3%3][i1%3];
							if (k1 == k2) {
								sw = false;
								bd[i1/3+i2/3*3].tx[i2%3][i1%3].setForeground(Color.red);
								bd[i1/3+i3/3*3].tx[i3%3][i1%3].setForeground(Color.red);
							}
						}
					}
				}
			}
		}

		return sw;
	}
}

/******************/
/* ゲームの遊び方 */
/******************/
class Method extends JDialog
{
			// コンストラクタ
	Method()
	{
		setTitle("ゲームの遊び方");
				// ContetPain
		Container cp = getContentPane();
		cp.setLayout(new FlowLayout(FlowLayout.CENTER));
		cp.setBackground(new Color(220, 255, 220));   // 背景色
		Font f = new Font("ＭＳ 明朝", Font.PLAIN, 20);
		setSize(850, 370);
				// TextArea の追加
		JTextArea ta = new JTextArea(15, 80);
		ta.setFont(f);
		ta.setEditable(false);
		ta.setLineWrap(true);
		ta.setText("１．スタート画面\n");
		ta.append("\n");
		ta.append("　ａ．味方１： 配置したい位置をマウスでクリックした後，1 のキーを押せば（ 3 のキーを押せばキャンセル）配置され，左方向に動き出す．敵と接触することによって敵を消滅させることができる．配置できる上限数のデフォルトは 10 である．\n");
		ta.append("\n");
		ta.append("　ｂ．味方２： 配置したい位置をマウスでクリックした後，2 のキーを押せば（ 3 のキーを押せばキャンセル）配置される．その位置に停止したままであるが，その近傍を通過した敵を消滅させることができる．配置できる上限数のデフォルトは 4 である．\n");
		ta.append("\n");
		ta.append("２．ゲーム画面\n");
		ta.append("\n");
		ta.append("　ａ．最初から決まっている数字に対しては，背景色が薄い緑になり，修正することができません．それ以外の空いている箇所に数字を入力し，「return」キーをクリックすることによって数字を設定していきます．（ step1 ）\n");
		ta.append("\n");
		ta.append("　ｂ．数字を入力する際，ルール違反が起こっている場合は，数字色が赤になります．（ step2 ）\n");
		ta.append("\n");
		ta.append("　ｃ．1 ～ 9 までの番号が付けられているボタン（「数字」ボタンと呼ぶ）の下にあるテキストフィールドには，各数字に対する出現回数が表示されます．この値が 9 になるとテキストフィールドの背景色が赤になります．上に示すゲーム版の数字色がすべて黒で，かつ，すべてのテキストフィールドの背景色が赤になった時点でゲーム終了となります．（ step3 ）\n");
		ta.append("\n");
		ta.append("　ｄ．「数字」ボタンをクリックすると，ゲーム版の対応する数字を入力可能な場所の背景色がピンクになります．（ step4 ）\n");
		ta.append("\n");
		ta.append("　ｅ．「記憶」ボタンをクリックするとことによって，現在の状態を記憶することが出来ます．また，「戻る」ボタンをクリックすることによって，最後に記憶した状態まで順番に戻すことが出来ます．なお，「記憶」ボタンは，「return」キーによって入力する数字を確定した後にクリックして下さい．（ step5 ）\n");
		JScrollPane scroll = new JScrollPane(ta);
		cp.add(scroll);
				// Window を閉じるため
		addWindowListener(new WinEnd());
	}
				// 終了処理
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			setVisible(false);
		}
	}
}
