package game;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import main.*;

public class GamePanel extends JPanel implements ActionListener
{
	MainPanel mp;
	Bord bd[] = new Bord [9];
	JTextField ct[] = new JTextField [9];
	JButton memory, back, next, end, num_b[] = new JButton [9];
	Stack <int[][][]> kp = new Stack <int[][][]> ();
			//
			// コンストラクタ
			//
	public GamePanel(Dimension size, MainPanel mp1)
	{
		mp = mp1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(new Color(220, 255, 220));   // 背景色
					// パネルの配置
		JPanel jp = new JPanel();
		jp.setSize(size.width, size.width);
		jp.setLocation(0, 0);
		jp.setBackground(Color.green);
		add(jp);
							// グリッドレイアウト
		jp.setLayout(new GridLayout(3, 3, 5, 5));
							// ボードの配置
		for (int i1 = 0; i1 < 9; i1++) {
			bd[i1] = new Bord(i1, mp);
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++)
					bd[i1].tx[i2][i3].addActionListener(this);
			}
			jp.add(bd[i1]);
		}
					// 数字ボタンの配置
		JPanel num = new JPanel();
		num.setBackground(new Color(220, 255, 220));
		num.setSize(size.width, 30);
		num.setLocation(0, 500);
		add(num);
		num.setLayout(new GridLayout(1, 9, 5, 5));
		for (int i1 = 0; i1 < 9; i1++) {
			num_b[i1] = new JButton(Integer.toString(i1+1));
			num_b[i1].setFont(new Font("SansSerif", Font.BOLD, 20));
			num_b[i1].addActionListener(this);
			num.add(num_b[i1]);
		}
					// カウンタフィールドの配置
		JPanel count_f = new JPanel();
		count_f.setBackground(new Color(220, 255, 220));
		count_f.setSize(size.width, 30);
		count_f.setLocation(0, 530);
		add(count_f);
		count_f.setLayout(new GridLayout(1, 9, 5, 5));
		for (int i1 = 0; i1 < 9; i1++) {
			ct[i1] = new JTextField();
			ct[i1].setFont(new Font("SansSerif", Font.BOLD, 20));
			ct[i1].setBackground(Color.white);
			ct[i1].setHorizontalAlignment(JTextField.CENTER);
			ct[i1].setEditable(false);
			count_f.add(ct[i1]);
		}
					// 「記憶」ボタンの配置
		Font f = new Font("SansSerif", Font.BOLD, 20);
		memory = new JButton("記憶");
		memory.setFont(f);
		memory.setSize(80, 40);
		memory.setLocation(50, 560);
		memory.addActionListener(this);
		add(memory);
					// 「戻る」ボタンの配置
		back = new JButton("戻る");
		back.setFont(f);
		back.setSize(80, 40);
		back.setLocation(140, 560);
		back.addActionListener(this);
		back.setVisible(false);
		add(back);
					// 「次の問題」ボタンの配置
		next = new JButton("次の問題");
		next.setFont(f);
		next.setSize(120, 40);
		next.setLocation(230, 560);
		next.addActionListener(this);
		add(next);
					// 「終了」ボタンの配置
		end = new JButton("終了");
		end.setFont(f);
		end.setSize(80, 40);
		end.setLocation(360, 560);
		end.addActionListener(this);
		add(end);
					// 数字の数を数える
		count();
	}
			//
			// ボタンがクリックされたときの処理
			//
	public void actionPerformed(ActionEvent e)
	{
					// 「記憶」ボタン
		if (e.getSource() == memory) {
			back.setVisible(true);
			int state [][][] = new int [9][3][3];
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 3; i2++) {
					for (int i3 = 0; i3 < 3; i3++)
						state[i1][i2][i3] = mp.pr[i1][i2][i3];
				}
			}
			kp.push(state);
			Message msg = new Message(kp.size());
			msg.setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
			msg.setLocation(0, 550);
			msg.setVisible(true);
		}
					// 「戻る」ボタン
		else if (e.getSource() == back) {
			mp.pr = kp.pop();
			if (kp.size() == 0)
				back.setVisible(false);
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 3; i2++) {
					for (int i3 = 0; i3 < 3; i3++) {
						if (mp.pr[i1][i2][i3] != 0)
							bd[i1].tx[i2][i3].setText(Integer.toString(mp.pr[i1][i2][i3]));
						else
							bd[i1].tx[i2][i3].setText("");
					}
				}
			}
			boolean sw = check();
			if (sw)
				count();
		}
					// 「終了」ボタン
		else if (e.getSource() == end)
			mp.state = 2;
					// 「次の問題」ボタン
		else if (e.getSource() == next)
			mp.state = 0;
					// 数字ボタン
		else if (e.getSource() == num_b[0] || e.getSource() == num_b[1] || e.getSource() == num_b[2] || e.getSource() == num_b[3] || e.getSource() == num_b[4] || e.getSource() == num_b[5] || e.getSource() == num_b[6] || e.getSource() == num_b[7] || e.getSource() == num_b[8]) {
			for (int i1 = 0; i1 < 9; i1++)
				num_b[i1].setForeground(Color.black);
			int k;
			if (e.getSource() == num_b[0])
				k = 1;
			else if (e.getSource() == num_b[1])
				k = 2;
			else if (e.getSource() == num_b[2])
				k = 3;
			else if (e.getSource() == num_b[3])
				k = 4;
			else if (e.getSource() == num_b[4])
				k = 5;
			else if (e.getSource() == num_b[5])
				k = 6;
			else if (e.getSource() == num_b[6])
				k = 7;
			else if (e.getSource() == num_b[7])
				k = 8;
			else
				k = 9;
			num_b[k-1].setForeground(Color.green);
			safe(k);
		}
					// 数字が入力されたとき
		else {
			int k;
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 3; i2++) {
					for (int i3 = 0; i3 < 3; i3++) {
						String str = bd[i1].tx[i2][i3].getText();
						if (str.length() > 0) {
							try {
								k = Integer.parseInt(str);
								if (k == 0)
									k = -1;
							}
							catch (NumberFormatException ne)
							{
								k = -1;
							}
						}
						else
							k = 0;
						mp.pr[i1][i2][i3] = k;
					}
				}
			}
			boolean sw = check();
			if (sw)
				count();
		}
	}
			//
			// データは適切か？
			//
	boolean check()
	{
		boolean sw = true;
					// 背景色のクリア
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++) {
					if (mp.wk[i1][i2][i3] == 0)
						bd[i1].tx[i2][i3].setBackground(Color.white);
				}
			}
		}
					// 数字の適切性
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++) {
					bd[i1].tx[i2][i3].setForeground(Color.black);
					if (mp.pr[i1][i2][i3] < 0 || mp.pr[i1][i2][i3] > 9) {
						sw = false;
						bd[i1].tx[i2][i3].setForeground(Color.red);
					}
				}
			}
		}
					// ブロック内
		if (sw) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 8; i2++) {
					int k1 = mp.pr[i1][i2/3][i2%3];
					if (k1 > 0) {
						for (int i3 = i2+1; i3 < 9; i3++) {
							int k2 = mp.pr[i1][i3/3][i3%3];
							if (k1 == k2) {
								sw = false;
								bd[i1].tx[i2/3][i2%3].setForeground(Color.red);
								bd[i1].tx[i3/3][i3%3].setForeground(Color.red);
							}
						}
					}
				}
			}
		}
					// 行内
		if (sw) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 8; i2++) {
					int k1 = mp.pr[i1/3*3+i2/3][i1%3][i2%3];
					if (k1 > 0) {
						for (int i3 = i2+1; i3 < 9; i3++) {
							int k2 = mp.pr[i1/3*3+i3/3][i1%3][i3%3];
							if (k1 == k2) {
								sw = false;
								bd[i1/3*3+i2/3].tx[i1%3][i2%3].setForeground(Color.red);
								bd[i1/3*3+i3/3].tx[i1%3][i3%3].setForeground(Color.red);
							}
						}
					}
				}
			}
		}
					// 列内
		if (sw) {
			for (int i1 = 0; i1 < 9; i1++) {
				for (int i2 = 0; i2 < 8; i2++) {
					int k1 = mp.pr[i1/3+i2/3*3][i2%3][i1%3];
					if (k1 > 0) {
						for (int i3 = i2+1; i3 < 9; i3++) {
							int k2 = mp.pr[i1/3+i3/3*3][i3%3][i1%3];
							if (k1 == k2) {
								sw = false;
								bd[i1/3+i2/3*3].tx[i2%3][i1%3].setForeground(Color.red);
								bd[i1/3+i3/3*3].tx[i3%3][i1%3].setForeground(Color.red);
							}
						}
					}
				}
			}
		}

		return sw;
	}
			//
			// 数字の数を数える
			//
	void count()
	{
		for (int i1 = 0; i1 < 9; i1++) {
			int k1 = i1 + 1;
			int n = 0;
			for (int i2 = 0; i2 < 9; i2++) {
				for (int i3 = 0; i3 < 3; i3++) {
					for (int i4 = 0; i4 < 3; i4++) {
						if (mp.pr[i2][i3][i4] == k1)
							n++;
					}
				}
			}
			ct[i1].setText(Integer.toString(n));
			if (n == 9)
				ct[i1].setBackground(Color.red);
			else
				ct[i1].setBackground(Color.white);
		}
	}
			//
			// 数字がおける場所
			//
	void safe(int k)
	{
					// ブロック内
		for (int i1 = 0; i1 < 9; i1++) {
			boolean sw = false;
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++) {
					if (mp.wk[i1][i2][i3] == 2)
						mp.wk[i1][i2][i3] = 0;
					else if (mp.wk[i1][i2][i3] == 0)
						bd[i1].tx[i2][i3].setBackground(Color.white);
					if (mp.pr[i1][i2][i3] == k)
						sw = true;
				}
			}
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++) {
					if (mp.wk[i1][i2][i3] == 0 && (mp.pr[i1][i2][i3] > 0 || sw))
						mp.wk[i1][i2][i3] = 2;
				}
			}
		}
					// 行内
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 9; i2++) {
				int k1 = mp.pr[i1/3*3+i2/3][i1%3][i2%3];
				if (k1 == k) {
					for (int i3 = 0; i3 < 9; i3++) {
						if (mp.wk[i1/3*3+i3/3][i1%3][i3%3] == 0)
							mp.wk[i1/3*3+i3/3][i1%3][i3%3] = 2;
					}
					break;
				}
			}
		}
					// 列内
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 9; i2++) {
				int k1 = mp.pr[i1/3+i2/3*3][i2%3][i1%3];
				if (k1 == k) {
					for (int i3 = 0; i3 < 9; i3++) {
						if (mp.wk[i1/3+i3/3*3][i3%3][i1%3] == 0)
							mp.wk[i1/3+i3/3*3][i3%3][i1%3] = 2;
					}
					break;
				}
			}
		}
					// 背景色の変更
		for (int i1 = 0; i1 < 9; i1++) {
			for (int i2 = 0; i2 < 3; i2++) {
				for (int i3 = 0; i3 < 3; i3++) {
					if (mp.wk[i1][i2][i3] == 0)
						bd[i1].tx[i2][i3].setBackground(new Color(255, 215, 0));
				}
			}
		}
	}
}

/******************/
/* Message クラス */
/******************/
class Message extends JDialog {
					// コンストラクタ
	Message(int ct)
	{
		super();

		Container cp = getContentPane();
		cp.setLayout(new GridLayout(1, 1, 5, 5));
		setSize(200, 100);

		JTextArea ta = new JTextArea(2, 25);
		ta.setFont(new Font("SansSerif", Font.BOLD, 20));
		ta.setBackground(Color.white);
		ta.setEditable(false);
		ta.setText("状態を記憶しました\n　記憶状態数 = " + ct);
		cp.add(ta);

		addWindowListener(new WinEnd());
	}
					// 終了処理
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			setVisible(false);
		}
	}
}
