package game;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Bord extends JPanel implements ActionListener
{
	GamePanel gp;
	Koma km[][] = new Koma [8][8];
	int b_w = -1;   // -1:黒の手番，1:白の手番
	int st[][] = {{0, 0, 0, 0, 0, 0, 0, 0},
	              {0, 0, 0, 0, 0, 0, 0, 0},
	              {0, 0, 0, 0, 0, 0, 0, 0},
	              {0, 0, 0, 1, -1, 0, 0, 0},
	              {0, 0, 0, -1, 1, 0, 0, 0},
	              {0, 0, 0, 0, 0, 0, 0, 0},
	              {0, 0, 0, 0, 0, 0, 0, 0},
	              {0, 0, 0, 0, 0, 0, 0, 0}};   // 盤面の状態（0:コマが置かれてない，-1:黒，1:白）
	int n[] = new int [9];   // 指定された位置の各方向に対する反転できるコマの数
	                         //    [0] : 上方向
	                         //    [1] : 斜め右上方向
	                         //    [2] : 右方向
	                         //    [3] : 斜め右下方向
	                         //    [4] : 下方向
	                         //    [5] : 斜め左下方向
	                         //    [6] : 左方向
	                         //    [7] : 斜め左上方向
	                         //    [8] : 全体
			// コンストラクタ
	public Bord(Dimension size, GamePanel gp1)
	{
		int width;   // ボタンの大きさ
		int gap = 3;   // ボタン間の隙間の幅
		gp = gp1;
					// グリッドレイアウト
		setLayout(new GridLayout(8, 8, gap, gap));
					// 背景色の設定
		setBackground(new Color(165, 42, 42));
					// ボタンの配置
		width = (size.width - 9 * gap) / 8;
		for (int i1 = 0; i1 < 8; i1++) {
			for (int i2 = 0; i2 < 8; i2++) {
				km[i1][i2] = new Koma(width);
				km[i1][i2].addActionListener(this);
				if (st[i1][i2] != 0)
					km[i1][i2].st = st[i1][i2];
				add(km[i1][i2]);
			}
		}
					// コンピュータの操作
		if (gp.mp.method == 2) {
			int k[] = computer();   // コマを置く場所の決定
			set(k);   // コマを置く
		}
	}
			//
			// ボタンがクリックされたときの処理
			//
	public void actionPerformed(ActionEvent e)
	{
					// クリックされたボタンを特定
		int k[] = {-1, -1};
		for (int i1 = 0; i1 < 8 && k[0] < 0; i1++) {
			for (int i2 = 0; i2 < 8 && k[0] < 0; i2++) {
				if (e.getSource() == km[i1][i2]) {
					k[0] = i1;
					k[1] = i2;
				}
			}
		}
					// 反転できるコマを探す
		r_check(k);
							// 反転するコマがない場合
		if (n[8] <= 0) {
			gp.ta.setForeground(Color.red);
			if (gp.mp.method > 0)
				gp.ta.setText("あなたの番ですが，\n");
			else {
				if (b_w < 0)
					gp.ta.setText("黒の番ですが，\n");
				else
					gp.ta.setText("白の番ですが，\n");
			}
			gp.ta.append("そこへはコマを置けません．\n");
		}
							// 反転するコマがある場合
		else
			set(k);
	}
			//
			// コマの操作
			//
	void set(int k[])
	{
					// 反転
		reverse(k);
		b_w = -b_w;
					// コマの数を数え，勝敗決定のチェック
		int b = 0, w = 0, total = 0;
		for (int i1 = 0; i1 < 8; i1++) {
			for (int i2 = 0; i2 < 8; i2++) {
				if (st[i1][i2] != 0) {
					total++;
					if (st[i1][i2] < 0)
						b++;
					else
						w++;
				}
			}
		}
					// 勝敗決定
		if (total == 64) {
			gp.ta.setForeground(Color.black);
			gp.ta.setText("黒 " + b + " 個， 白 " + w + " 個\n");
			if (gp.mp.method > 0) {
				if (b == w)
					gp.ta.append("引き分けです．\n");
				else if (b > w && gp.mp.method == 1 || b < w && gp.mp.method == 2)
					gp.ta.append("あなたの勝ちです．\n");
				else
					gp.ta.append("コンピュータの勝ちです．\n");
			}
			else {
				if (b > w)
					gp.ta.append("黒の勝ちです．\n");
				else if (b == w)
					gp.ta.append("引き分けです．\n");
				else
					gp.ta.append("白の勝ちです．\n");
			}
			for (int i1 = 0; i1 < 8; i1++) {
				for (int i2 = 0; i2 < 8; i2++)
					km[i1][i2].setEnabled(false);
			}
		}
					// 勝負継続
		else {
			gp.ta.setForeground(Color.black);
			gp.ta.setText("黒 " + b + " 個， 白 " + w + " 個\n");
							// スキップのチェック
			boolean sw = false;
			for (int i1 = 0; i1 < 8 && !sw; i1++) {
				for (int i2 = 0; i2 < 8 && !sw; i2++) {
					k[0] = i1;
					k[1] = i2;
					r_check(k);
					if (n[8] > 0)
						sw = true;
				}
			}
							// 対コンピュータ
			if (gp.mp.method > 0) {
									// スキップの場合
				if (!sw) {
					b_w = -b_w;
					gp.ta.append("コマを置けないため，スキップし，\n");
					if (gp.mp.method == 1 && b_w < 0)
						gp.ta.append("あなた（黒）の番です．\n");
					else if (gp.mp.method == 2 && b_w > 0)
						gp.ta.append("あなた（白）の番です．\n");
					else {
						gp.ta.append("コンピュータの番です．\n");
						k = computer();   // コマを置く場所の決定
						set(k);   // コマを置く
					}
				}
									// 次の手
				else {
					if (gp.mp.method == 1 && b_w < 0)
						gp.ta.append("あなた（黒）の番です．\n");
					else if (gp.mp.method == 2 && b_w > 0)
						gp.ta.append("あなた（白）の番です．\n");
					else {
						gp.ta.append("コンピュータの番です．\n");
						k = computer();   // コマを置く場所の決定
						set(k);   // コマを置く
					}
				}
			}
							// 対人間
			else {
									// スキップの場合
				if (!sw) {
					gp.ta.append("コマを置けないため，スキップし，\n");
					b_w = -b_w;
				}
									// 次の手
				if (b_w < 0)
					gp.ta.append("黒の番です．\n");
				else
					gp.ta.append("白の番です．\n");
			}
		}
	}
			//
			// k[0] 行 k[1] 列に黒または白（ b_w ）のコマを置いた場合，反転できるコマを探す
			//
	void r_check(int k[])
	{
		int d[][] = {{-1, 0}, {-1, 1}, {0, 1}, {1, 1}, {1, 0}, {1, -1}, {0, -1}, {-1, -1}};
		n[8] = 0;
		if (st[k[0]][k[1]] == 0) {
			for (int i1 = 0; i1 < 8; i1++) {
				int m1 = k[0], m2 = k[1];
				n[i1]  = 0;
				int s  = 0;   // 0:開始，1:カウント，2:カウント終了，3:反転不可能
				int ct = 0;
				while (s < 2) {
					m1 += d[i1][0];
					m2 += d[i1][1];
					if (m1 >= 0 && m1 < 8 && m2 >= 0 && m2 < 8) {
						if (st[m1][m2] == 0)
							s = 3;
						else if (st[m1][m2] == b_w) {
							if (s == 1)
								s = 2;
							else
								s = 3;
						}
						else {
							s = 1;
							ct++;
						}
					}
					else
						s = 3;
				}
				if (s == 2) {
					n[8]  += ct;
					n[i1]  = ct;
				}
			}
		}
	}
			//
			// k[0] 行 k[1] 列に黒または白（ b_w ）のコマを置いた場合におけるコマの反転
			//
	void reverse(int k[])
	{
		int d[][] = {{-1, 0}, {-1, 1}, {0, 1}, {1, 1}, {1, 0}, {1, -1}, {0, -1}, {-1, -1}};
		for (int i1 = 0; i1 < 8; i1++) {
			int m1 = k[0], m2 = k[1];
			for (int i2 = 0; i2 < n[i1]; i2++) {
				m1 += d[i1][0];
				m2 += d[i1][1];
				km[m1][m2].st = b_w;
				st[m1][m2]    = b_w;
			}
		}
		km[k[0]][k[1]].st = b_w;
		st[k[0]][k[1]]    = b_w;
					// 描画
		for (int i1 = 0; i1 < 8; i1++) {
			for (int i2 = 0; i2 < 8; i2++) {
				if (st[i1][i2] != 0)
					km[i1][i2].repaint();
			}
		}
	}
			//
			// コンピュータが置くコマの場所を決定
			//
	int [] computer()
	{
		int k[] = new int [2];
		int kk[] = new int [2];
		int mx[] = new int [9];
		mx[8] = 0;
		for (int i1 = 0; i1 < 8; i1++) {
			for (int i2 = 0; i2 < 8; i2++) {
				kk[0] = i1;
				kk[1] = i2;
				r_check(kk);
				if (n[8] > mx[8]) {
					k[0] = kk[0];
					k[1] = kk[1];
					for (int i3 = 0; i3 < 9; i3++)
						mx[i3] = n[i3];
				}
			}
		}
		for (int i1 = 0; i1 < 9; i1++)
			n[i1] = mx[i1];
		return k;
	}
}
