package over;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import main.*;

public class GameOverPanel extends JPanel implements ActionListener
{
	Dimension size;   // パネルの大きさ
	MainPanel mp;
	JButton bt1, bt2;
			// コンストラクタ
	public GameOverPanel(Dimension size1, MainPanel mp1)
	{
		size = size1;
		mp   = mp1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(Color.white);
					// ボタンの配置
		Font f = new Font("SansSerif", Font.BOLD, 15);
		FontMetrics fm = getFontMetrics(f);
		String str1 = "終了";
		int w1 = fm.stringWidth(str1) + 40;
		int h1 = fm.getHeight() + 10;
		bt1 = new JButton(str1);
		bt1.setFont(f);
		bt1.addActionListener(this);   // アクションリスナ
		bt1.setSize(w1, h1);

		String str2 = "再開";
		int w2 = fm.stringWidth(str2) + 40;
		int h2 = fm.getHeight() + 10;
		bt2 = new JButton(str2);
		bt2.setFont(f);
		bt2.addActionListener(this);   // アクションリスナ
		bt2.setSize(w2, h2);

		int w = size.width / 2 - (w1 + w2 + 5) / 2;
		bt1.setLocation(w, size.height-h1-20);
		add(bt1);
		w += (w1 + 5);
		bt2.setLocation(w, size.height-h1-20);
		add(bt2);
	}
			// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
		Font f = new Font("SansSerif", Font.BOLD, 40);
		FontMetrics fm = g.getFontMetrics(f);
		String str = "Game";
		int w = fm.stringWidth(str);
		int h = fm.getHeight();
		g.setFont(f);
		g.drawString(str, size.width/2-w/2, size.height/2-h/2);
		str = "Over!";
		w   = fm.stringWidth(str);
		g.drawString(str, size.width/2-w/2, size.height/2+h/2);
	}
			// ボタンがクリックされたときの処理
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == bt1) {   // ゲーム終了
			mp.state = 3;
			bt1.setEnabled(false);
			bt2.setEnabled(false);
		}
		else   // 最初からゲーム再開
			mp.state = 0;
	}
}
