package game;

import java.awt.*;
import javax.swing.*;
import java.util.Random;
import main.*;

class Puyo extends JPanel implements Runnable
{
	MainPanel mp;
	int p_x, p_y;   // 左または上のピースの座標
	int row, col;   // ゲーム画面の行と列数
	int width;   // ピースの幅と高さ
	int rot;   // 0:横，1:縦
	int p[][];   // 画面の状態（0:存在しない，1:赤，2:ピンク，3:緑，4:青）
	Color color[] = {Color.red, Color.pink, Color.green, Color.blue};   // ピースの色
	Thread th;
	boolean in_game = true;
	Random rn;
			// コンストラクタ
	public Puyo(int row1, int col1, int width1, MainPanel mp1)
	{
		mp    = mp1;
		row   = row1;
		col   = col1;
		width = width1;
		p     = new int [row][col];
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(Color.white);
					// ランダム変数の初期化
		rn = new Random();
					// ピースの選択
		select();
					// スレッドの生成
		th = new Thread(this);
		th.start();
	}
			// スレッドの実行
	public void run()
	{
		while (in_game) {
			try {
				th.sleep(500);
			}
			catch (InterruptedException e) {}
					// ピースの落下
			if (p_y < row-1) {
				p[p_y+1][p_x]   = p[p_y][p_x];
				p[p_y+1][p_x+1] = p[p_y][p_x+1];
				p[p_y][p_x]     = 0;
				p[p_y][p_x+1]   = 0;
				p_y++;
			}
			else
				select();   // 次のピース
					// 再描画
			repaint();
		}
	}
			// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
		for (int i1 = 0; i1 < row; i1++) {
			for (int i2 = 0; i2 < col; i2++) {
				if (p[i1][i2] > 0) {
					g.setColor(color[p[i1][i2]-1]);
					g.fillRect(i2*width, i1*width, width, width);
				}
			}
		}
	}
			// ピースの選択
	void select()
	{
		p_y         = 0;
		p_x         = rn.nextInt(col - 1);
		p[0][p_x]   = 1 + rn.nextInt(4);
		p[0][p_x+1] = 1 + rn.nextInt(4);
	}
}
