package game;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Random;
import main.*;

public class GamePanel extends JPanel implements ActionListener
{
	MainPanel mp;
	JButton bt[][] = new JButton [3][3];
	Random rn;
	int i_state[][] = {{1, 2, 3}, {8, 0, 4}, {7, 6, 5}};
	int g_state[][] = {{1, 2, 3}, {8, 0, 4}, {7, 6, 5}};
			// コンストラクタ
	public GamePanel(Dimension size, MainPanel mp1)
	{
		mp = mp1;
					// グリッドレイアウト
		setLayout(new GridLayout(3, 3, 10, 10));
					// 背景色の設定
		setBackground(Color.white);
					// ボタンの配置
		Font f = new Font("SansSerif", Font.BOLD, 25);
		for (int i1 = 0; i1 < 3; i1++) {
			for (int i2 = 0; i2 < 3; i2++) {
				bt[i1][i2] = new JButton();
				bt[i1][i2].setBackground(Color.cyan);
				bt[i1][i2].setFont(f);
				bt[i1][i2].addActionListener(this);   // アクションリスナ
				add(bt[i1][i2]);
			}
		}
					// ランダム変数の初期化
		rn = new Random();
					// 初期状態の生成
		create();
					// ボタンへ名前を表示
		for (int i1 = 0; i1 < 3; i1++) {
			for (int i2 = 0; i2 < 3; i2++) {
				if (i_state[i1][i2] > 0)
					bt[i1][i2].setText(Integer.toString(i_state[i1][i2]));
			}
		}
	}
			// 初期状態の生成
	void create()
	{
		int ct = (mp.level == 1) ? 10 : 100;
		int dr, k1, k2, wk;
		boolean sw = true;

		while (sw) {
			k1 = 1;
			k2 = 1;
					// 移動
			for (int i1 = 0; i1 < ct; i1++) {
				dr = rn.nextInt(4);
				switch (dr) {
					case 0:   // 上
						if (k1 > 0) {
							wk                = i_state[k1-1][k2];
							i_state[k1-1][k2] = 0;
							i_state[k1][k2]   = wk;
							k1--;
						}
						break;
					case 1:   // 下
						if (k1 < 2) {
							wk                = i_state[k1+1][k2];
							i_state[k1+1][k2] = 0;
							i_state[k1][k2]   = wk;
							k1++;
						}
						break;
					case 2:   // 左
						if (k2 > 0) {
							wk                = i_state[k1][k2-1];
							i_state[k1][k2-1] = 0;
							i_state[k1][k2]   = wk;
							k2--;
						}
						break;
					default:   // 右
						if (k2 < 2) {
							wk                = i_state[k1][k2+1];
							i_state[k1][k2+1] = 0;
							i_state[k1][k2]   = wk;
							k2++;
						}
						break;
				}
			}
					// ゴールと同じか否かのチェック
			for (int i1 = 0; i1 < 3 && sw; i1++) {
				for (int i2 = 0; i2 < 3 && sw; i2++) {
					if (i_state[i1][i2] != g_state[i1][i2])
						sw = false;
				}
			}
		}
	}
			// ボタンがクリックされたときの処理
	public void actionPerformed(ActionEvent e)
	{
		int sw = 0;
					// 移動
		for (int i1 = 0; i1 < 3 && sw == 0; i1++) {
			for (int i2 = 0; i2 < 3 && sw == 0; i2++) {
				if (e.getSource() == bt[i1][i2]) {
					sw = 1;
					if (i1 > 0 && i_state[i1-1][i2] == 0) {   // 上
						sw = 2;
						bt[i1][i2].setText("");
						bt[i1-1][i2].setText(Integer.toString(i_state[i1][i2]));
						i_state[i1-1][i2] = i_state[i1][i2];
						i_state[i1][i2]   = 0;
					}
					else if (i1 < 2 && i_state[i1+1][i2] == 0) {   // 下
						sw = 2;
						bt[i1][i2].setText("");
						bt[i1+1][i2].setText(Integer.toString(i_state[i1][i2]));
						i_state[i1+1][i2] = i_state[i1][i2];
						i_state[i1][i2]   = 0;
					}
					else if (i2 > 0 && i_state[i1][i2-1] == 0) {   // 左
						sw = 2;
						bt[i1][i2].setText("");
						bt[i1][i2-1].setText(Integer.toString(i_state[i1][i2]));
						i_state[i1][i2-1] = i_state[i1][i2];
						i_state[i1][i2]   = 0;
					}
					else if (i2 < 2 && i_state[i1][i2+1] == 0) {   // 右
						sw = 2;
						bt[i1][i2].setText("");
						bt[i1][i2+1].setText(Integer.toString(i_state[i1][i2]));
						i_state[i1][i2+1] = i_state[i1][i2];
						i_state[i1][i2]   = 0;
					}
				}
			}
		}
					// ゴールか？
		if (sw > 1) {
			for (int i1 = 0; i1 < 3 && sw > 1; i1++) {
				for (int i2 = 0; i2 < 3 && sw > 1; i2++) {
					if (i_state[i1][i2] != g_state[i1][i2])
						sw = 0;
				}
			}
			if (sw > 1)
				mp.state = 2;
		}
	}
}
