package game;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Random;
import main.*;

public class GamePanel extends JPanel implements ActionListener, Runnable
{
	Dimension size;   // パネルの大きさ
	MainPanel mp;
	JButton left, right;
	My my;   // 自機
	Boss bs;   // ボス
	int no = 2;   // 敵機の数
	Enemy em[] = new Enemy [no];   // 敵機
	boolean ex[] = new boolean [no];   // 敵機の存在
	Random rn;
	Thread td;
	boolean in_game = true;
			// コンストラクタ
	public GamePanel(Dimension size1, MainPanel mp1)
	{
		size = size1;
		mp   = mp1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(Color.white);
					// ボタンの配置
		Font f = new Font("SansSerif", Font.BOLD, 15);
		FontMetrics fm = getFontMetrics(f);
		String str1 = "ゲームクリア";
		int w1 = fm.stringWidth(str1) + 40;
		int h1 = fm.getHeight() + 10;
		left = new JButton(str1);
		left.setFont(f);
		left.addActionListener(this);   // アクションリスナ
		left.setSize(w1, h1);

		String str2 = "ゲームオーバー";
		int w2 = fm.stringWidth(str2) + 40;
		int h2 = fm.getHeight() + 10;
		right = new JButton(str2);
		right.setFont(f);
		right.addActionListener(this);   // アクションリスナ
		right.setSize(w2, h2);

		int w = size.width / 2 - (w1 + w2 + 5) / 2;
		int h = size.height - h1 - 10;
		left.setLocation(w, h);
		add(left);
		right.setLocation(w+w1+5, h);
		add(right);
					// ランダム変数の初期化
		rn = new Random();
					// 自機，ボス，敵機の配置
		my = new My(size, mp);
		if (mp.level == 1) {
			ex[0] = false;
			ex[1] = false;
		}
		else {
			ex[0] = true;
			ex[1] = true;
		}
		bs = new Boss(size, rn, this, mp);
		if (ex[0])
			em[0] = new Enemy(bs, 0, size, rn, mp);
		if (ex[1])
			em[1] = new Enemy(bs, 1, size, rn, mp);
					// スレッドの生成
		td = new Thread(this);
		td.start();
					// キーリスナの追加
		addKeyListener(new Key());
	}
			// スレッドの実行
	public void run()
	{
		while (in_game) {
			try {
				td.sleep(10);
			}
			catch (InterruptedException e) {}
			repaint();
		}
	}
			// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
					// 自機
		g.drawImage(my.image, my.x, my.y, this);
					// ボス
		g.drawImage(bs.image, bs.x, bs.y, this);
					// 敵機
		for (int i1 = 0; i1 < no; i1++) {
			if (ex[i1])
				g.drawImage(em[i1].image, em[i1].x, em[i1].y, this);
		}
					// この Component が入力フォーカスを取得することを要求
		requestFocusInWindow();
	}
			// ボタンがクリックされたときの処理
	public void actionPerformed(ActionEvent e)
	{
		in_game = false;
		bs.in_game = false;
		if (e.getSource() == left)   // ゲームクリア
			mp.state = 2;
		else   // ゲームオーバー
			mp.state = 3;
	}
			// キーが押されたときの処理（イベントアダプタ）
	class Key extends KeyAdapter {
		public void keyPressed(KeyEvent ke)
		{
			if (ke.getKeyCode() == KeyEvent.VK_UP)   // 「↑」キー（ 38 ）
				my.y -= my.v;
			else if (ke.getKeyCode() == KeyEvent.VK_DOWN)   // 「↓」キー（ 40 ）
				my.y += my.v;
			else if (ke.getKeyCode() == KeyEvent.VK_LEFT)   // 「←」キー（ 37 ）
				my.x -= my.v;
			else if (ke.getKeyCode() == KeyEvent.VK_RIGHT)   // 「→」キー（ 39 ）
				my.x += my.v;
		}
	}
}
