package over;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import main.*;

public class GameOverPanel extends JPanel implements ActionListener
{
	Dimension size;   // パネルの大きさ
	MainPanel mp;
	JButton bt1, bt2, bt3;
			// コンストラクタ
	public GameOverPanel(Dimension size1, MainPanel mp1)
	{
		size = size1;
		mp   = mp1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(Color.white);
					// ボタンの配置
		Font f = new Font("SansSerif", Font.BOLD, 20);
		FontMetrics fm = getFontMetrics(f);
		String str;
		int x, y, w1, w2, w3, h;

		x = 0;
		str = "もう一度";
		w1 = fm.stringWidth(str) + 40;
		h = fm.getHeight() + 10;
		bt1 = new JButton(str);
		bt1.setFont(f);
		bt1.addActionListener(this);
		bt1.setSize(w1, h);
		y = size.height - h - 10;
		x += w1;

		str = "スタート画面";
		w2 = fm.stringWidth(str) + 40;
		bt2 = new JButton(str);
		bt2.setFont(f);
		bt2.addActionListener(this);
		bt2.setSize(w2, h);
		x += w2;

		str = "ゲーム終了";
		w3 = fm.stringWidth(str) + 40;
		bt3 = new JButton(str);
		bt3.setFont(f);
		bt3.addActionListener(this);
		bt3.setSize(w3, h);
		x += w3;

		x = size.width / 2 - x / 2 - 5;
		bt1.setLocation(x, y);
		add(bt1);
		x += (w1 + 5);
		bt2.setLocation(x, y);
		add(bt2);
		x += (w2 + 5);
		bt3.setLocation(x, y);
		add(bt3);
	}
			// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
		Font f = new Font("SansSerif", Font.BOLD, 40);
		FontMetrics fm = g.getFontMetrics(f);
		String str = "Game Over!";
		int w = fm.stringWidth(str);
		g.setFont(f);
		g.drawString(str, size.width/2-w/2, size.height/2);
	}
			// ボタンがクリックされたときの処理
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == bt1)   // もう一度同じゲームを実行
			mp.state = 1;
		else if (e.getSource() == bt2)   // スタート画面
			mp.state = 0;
		else if (e.getSource() == bt3) {   // ゲーム終了
			mp.state = 4;
			bt1.setEnabled(false);
			bt2.setEnabled(false);
			bt3.setEnabled(false);
		}
	}
}
