package start;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import main.*;
import map.*;

public class StartPanel extends JPanel implements ActionListener
{
	boolean in_game = true;
	Dimension size;   // パネルの大きさ
	MainPanel mp;
	JButton b_use, b_map, b_game;
	JTextField em1, em2, fr1, fr2, map;
			// コンストラクタ
	public StartPanel(Dimension size1, MainPanel mp1)
	{
		size = size1;
		mp   = mp1;
					// レイアウトマネージャの停止
		setLayout(null);
					// 背景色の設定
		setBackground(Color.white);
					// 実行条件設定エリア
		Font f = new Font("SansSerif", Font.BOLD, 20);
		FontMetrics fm = getFontMetrics(f);
		String str;
		int x, y, w1, w2, w3, h;
							// 敵
		x = 0;
		str = "敵の数：　敵１：";
		JLabel lb1 = new JLabel(str, JLabel.CENTER);
		lb1.setFont(f);
		w1 = fm.stringWidth(str);
		h = fm.getHeight();
		lb1.setSize(w1, h);
		y = size.height - h - 10;
		x += w1;

		em1 = new JTextField("10", 2);
		em1.setFont(f);
		em1.setSize(30, h);
		em1.setHorizontalAlignment(JTextField.RIGHT);
		x += 30;

		str = "　敵２：";
		w2 = fm.stringWidth(str);
		JLabel lb2 = new JLabel(str, JLabel.CENTER);
		lb2.setFont(f);
		lb2.setSize(w2, h);
		x += w2;

		em2 = new JTextField("5", 2);
		em2.setFont(f);
		em2.setSize(30, h);
		em2.setHorizontalAlignment(JTextField.RIGHT);
		x += 30;

		x = size.width / 2 - x / 2;
		lb1.setLocation(x, y);
		add(lb1);
		x += w1;
		em1.setLocation(x, y);
		add(em1);
		x += 30;
		lb2.setLocation(x, y);
		add(lb2);
		x += w2;
		em2.setLocation(x, y);
		add(em2);
							// 味方
		x = 0;
		str = "味方の数制限：　 味方１：";
		JLabel lb3 = new JLabel(str, JLabel.CENTER);
		lb3.setFont(f);
		w1 = fm.stringWidth(str);
		h = fm.getHeight();
		lb3.setSize(w1, h);
		y -= (h + 10);
		x += w1;

		fr1 = new JTextField("10", 2);
		fr1.setFont(f);
		fr1.setSize(30, h);
		fr1.setHorizontalAlignment(JTextField.RIGHT);
		x += 30;

		str = "　味方２：";
		w2 = fm.stringWidth(str);
		JLabel lb4 = new JLabel(str, JLabel.CENTER);
		lb4.setFont(f);
		lb4.setSize(w2, h);
		x += w2;

		fr2 = new JTextField("4", 2);
		fr2.setFont(f);
		fr2.setSize(30, h);
		fr2.setHorizontalAlignment(JTextField.RIGHT);
		x += 30;

		x = size.width / 2 - x / 2;
		lb3.setLocation(x, y);
		add(lb3);
		x += w1;
		fr1.setLocation(x, y);
		add(fr1);
		x += 30;
		lb4.setLocation(x, y);
		add(lb4);
		x += w2;
		fr2.setLocation(x, y);
		add(fr2);
							// マップ
		x = 0;
		str = "使用するマップ：";
		JLabel lb5 = new JLabel(str, JLabel.CENTER);
		lb5.setFont(f);
		w1 = fm.stringWidth(str);
		h = fm.getHeight();
		lb5.setSize(w1, h);
		y -= (h + 10);
		x += w1;

		map = new JTextField("1", 2);
		map.setFont(f);
		map.setSize(30, h);
		map.setHorizontalAlignment(JTextField.RIGHT);
		x += 30;

		x = size.width / 2 - x / 2;
		lb5.setLocation(x, y);
		add(lb5);
		x += w1;
		map.setLocation(x, y);
		add(map);
					// ボタンの配置
		x = 0;
		str = "遊び方";
		w1 = fm.stringWidth(str) + 40;
		h = fm.getHeight() + 10;
		b_use = new JButton(str);
		b_use.setFont(f);
		b_use.addActionListener(this);
		b_use.setSize(w1, h);
		y -= (h + 10);
		x += w1;

		str = "マップ編集";
		w2 = fm.stringWidth(str) + 40;
		b_map = new JButton(str);
		b_map.setFont(f);
		b_map.addActionListener(this);
		b_map.setSize(w2, h);
		x += w2;

		str = "ゲーム開始";
		w3 = fm.stringWidth(str) + 40;
		b_game = new JButton(str);
		b_game.setFont(f);
		b_game.addActionListener(this);
		b_game.setSize(w3, h);
		x += w3;

		x = size.width / 2 - x / 2 - 5;
		b_use.setLocation(x, y);
		add(b_use);
		x += (w1 + 5);
		b_map.setLocation(x, y);
		add(b_map);
		x += (w2 + 5);
		b_game.setLocation(x, y);
		add(b_game);
	}
			// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
		FontMetrics fm;
		Font f;
		String str;
		int w, h;

		f   = new Font("SansSerif", Font.BOLD, 40);
		fm  = g.getFontMetrics(f);
		str = "タワーディフェンスゲーム";
		w   = fm.stringWidth(str);
		h   = fm.getHeight();
		g.setFont(f);
		g.drawString(str, size.width/2-w/2, size.height/2);
	}
			// ボタンがクリックされたときの処理
	public void actionPerformed(ActionEvent e)
	{
					// 遊び方
		if (e.getSource() == b_use) {
			Method db = new Method();
			db.setVisible(true);
			requestFocusInWindow();
		}
					// ゲームクリア画面とゲームオーバー画面の確認
		else if (e.getSource() == b_map) {
			in_game  = false;
			mp.state = 2;   // ゲームクリア
//			mp.state = 3;   // ゲームオーバー
		}
					// ゲーム開始
		else if (e.getSource() == b_game) {
			int k = Integer.parseInt(map.getText()) - 1;
			if (k < 0 || k > 3)
				k = 0;
			Map.map = Map.map1[k];   // 使用するマップ
			mp.n_friend[0] = Integer.parseInt(fr1.getText());   // 味方１の数
			mp.n_friend[1] = Integer.parseInt(fr2.getText());   // 味方２の数
			mp.n_enemy[0] = Integer.parseInt(em1.getText());   // 敵１の数
			mp.n_enemy[1] = Integer.parseInt(em2.getText());   // 敵２の数
			mp.state = 1;
		}
	}
}

/******************/
/* ゲームの遊び方 */
/******************/
class Method extends JDialog
{
			// コンストラクタ
	Method()
	{
		setTitle("ゲームの遊び方");
				// ContetPain
		Container cp = getContentPane();
		cp.setLayout(new FlowLayout(FlowLayout.CENTER));
		cp.setBackground(new Color(220, 255, 220));   // 背景色
		Font f = new Font("ＭＳ 明朝", Font.PLAIN, 20);
		setSize(850, 370);
				// TextArea の追加
		JTextArea ta = new JTextArea(15, 80);
		ta.setFont(f);
		ta.setEditable(false);
		ta.setLineWrap(true);
		ta.setText("　左からランダムに現れる敵に対して，味方を適当な位置に配置することによって，敵が領域の右端に達するのを防ぐ．すべての敵を消滅させることができればゲームクリア，敵の一つでも領域の右端に達すればゲームオーバーとなる．\n");

		ta.append("\n");
		ta.append("Ⅰ．味方\n");
		ta.append("　ａ．味方１： 配置したい位置をマウスでクリックした後，1 のキーを押せば（ 3 のキーを押せばキャンセル）配置され，左方向に動き出す．敵と接触することによって敵を消滅させることができる．配置できる上限数のデフォルトは 10 である．\n");
		ta.append("　ｂ．味方２： 配置したい位置をマウスでクリックした後，2 のキーを押せば（ 3 のキーを押せばキャンセル）配置される．その位置に停止したままであるが，その近傍を通過した敵を消滅させることができる．配置できる上限数のデフォルトは 4 である．\n");
		ta.append("\n");
		ta.append("Ⅱ．敵\n");
		ta.append("　ａ．敵１： 左端から現れ，右方向に，障害物を避けながら動く．敵１の数のデフォルトは 10 である．\n");
		ta.append("　ｂ．敵２： 左端から現れ，右方向に，障害物を無視して動く．敵２の数のデフォルトは 5 である．\n");
		ta.append("\n");
		ta.append("Ⅲ．マップの編集： 既に存在する 3 種類のマップを編集したり，新しいマップを作成することができるが，マップの保存機能は持っていない．使用するマップを 1 から 4 で指定する（ 4 は障害物が何も無いマップ）．マップを編集したい場合は，「マップ編集」ボタンをクリックした後，障害物を配置したい位置をマウスでクリックし，1，または，2 のキーを押せば配置される．また，0 のキーを押せば障害物が無くなる．\n");
		JScrollPane scroll = new JScrollPane(ta);
		cp.add(scroll);
				// Window を閉じるため
		addWindowListener(new WinEnd());
	}
				// 終了処理
	class WinEnd extends WindowAdapter
	{
		public void windowClosing(WindowEvent e) {
			setVisible(false);
		}
	}
}
