package game;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Random;
import main.*;
import map.*;

public class GamePanel extends JPanel implements Runnable
{
	Dimension size;   // パネルの大きさ
	MainPanel mp;
	Thread td;
	boolean in_game = true;
	int count = 0;   // カウンタ
	int n_e_now;   // 出現していない敵の数
	int n_e_now_ex;   // 存在している敵の数
	int e_state[];   // 敵の状態（0:存在，1:動作中，-1：消滅）
	Enemy enemy[];   // 敵
	int next_time;   // 次の敵の出現時間
	int next;   // 次の敵
	Random rn;
	public Image mark;   // マーカー
	boolean mouse = false;
	int mark_x = 0;   // マーカーのｘ座標
	int mark_y = 0;   // マーカーのｙ座標
	int f_state[][];   // 味方の状態（0:存在，1:動作中，-1：消滅）
	Friend friend[][];   // 味方
			// コンストラクタ
	public GamePanel(Dimension size1, MainPanel mp1)
	{
		size = size1;
		mp   = mp1;
		rn   = new Random();
					// レイアウトマネージャの停止
		setLayout(null);
					// リスナの追加
		addMouseListener(new Mouse());   // マウスリスナ
		addKeyListener(new Key());   // キーリスナ
					// 背景色の設定
		setBackground(Color.white);
					// マーカー
		mark = mp.getToolkit().getImage("game/image/mark.jpg");
					// 味方
							// 味方の初期状態
		f_state = new int [mp.n_friend.length][];
		friend = new Friend [mp.n_friend.length][];
		for (int i1 = 0; i1 < mp.n_friend.length; i1++) {
			f_state[i1] = new int [mp.n_friend[i1]];
			friend[i1] = new Friend [mp.n_friend[i1]];
			for (int i2 = 0; i2 < mp.n_friend[i1]; i2++) {
				f_state[i1][i2] = 0;
				friend[i1][i2] = new Friend(i1, mp);
			}
		}
					// 敵
							// 敵の数
		n_e_now = mp.n_enemy[0] + mp.n_enemy[1];   // 出現していない敵の数
		n_e_now_ex = n_e_now;   // 存在している敵の数
							// 敵の初期状態
		e_state = new int [n_e_now];
		enemy = new Enemy [n_e_now];
		int k = 0;
		for (int i1 = 0; i1 < mp.n_enemy.length; i1++) {
			for (int i2 = 0; i2 < mp.n_enemy[i1]; i2++) {
				e_state[k] = 0;
				enemy[k] = new Enemy(i1, rn, mp);
				k++;
			}
		}
							// 次の敵
		next_time = (int)(30 * rn.nextDouble());
		next = (int)(e_state.length * rn.nextDouble());
		if (next >= e_state.length)
			next = e_state.length - 1;
					// スレッドの生成
		td = new Thread(this);
		td.start();
	}
			// スレッドの実行
	public void run()
	{
		while (in_game) {
			try {
				td.sleep(33);
			}
			catch (InterruptedException e) {}
			int sw = 0;
					// 味方の位置
							// 味方１
			for (int i1 = 0; i1 < f_state[0].length; i1++) {
				if (f_state[0][i1] > 0) {
									// 左へ移動
					if (friend[0][i1].state == 0) {
						friend[0][i1].x -= friend[0][i1].v;
						if (friend[0][i1].x < 0)
							f_state[0][i1] = -1;
						else {
							int k1 = (int)(friend[0][i1].y / Map.block_height);
							int k2 = (int)(friend[0][i1].x / Map.block_width);
							if (Map.map[k1][k2] > 0) {
								friend[0][i1].x = (k2 + 1) * Map.block_width;
								double r = rn.nextDouble();
								if (k1 == Map.map_row-1 && Map.map[k1-1][k2+1] == 0 || k1 > 0 && k1 < Map.map_row-1 && (Map.map[k1+1][k2+1] > 0 || r > 0.5 && Map.map[k1+1][k2+1] == 0 && Map.map[k1-1][k2+1] == 0))
									friend[0][i1].state = -1;   // 上へ
								else if (k1 == 0 && Map.map[k1+1][k2+1] == 0 || k1 > 0 && k1 < Map.map_row-1 && (Map.map[k1-1][k2+1] > 0 || r <= 0.5 && Map.map[k1+1][k2+1] == 0 && Map.map[k1-1][k2+1] == 0))
									friend[0][i1].state = 1;   // 下へ
							}
						}
					}
									// 上へ移動
					else if (friend[0][i1].state < 0) {
						friend[0][i1].y -= friend[0][i1].v;
						int k1 = (int)((friend[0][i1].y + Map.block_height) / Map.block_height);
						int k2 = (int)(friend[0][i1].x / Map.block_width) - 1;
						if (Map.map[k1][k2] == 0) {
							friend[0][i1].y = k1 * Map.block_height;
							friend[0][i1].state = 0;   // 左へ
						}
						else if (k1 == 0 || Map.map[k1-1][k2+1] > 0)
							friend[0][i1].state = 1;   // 下へ
					}
									// 下へ移動
					else {
						friend[0][i1].y += friend[0][i1].v;
						int k1 = (int)(friend[0][i1].y / Map.block_height);
						int k2 = (int)(friend[0][i1].x / Map.block_width) - 1;
						if (k1 >= Map.map_row-1) {
							friend[0][i1].y = k1 * Map.block_height;
							if (Map.map[k1][k2] == 0)
								friend[0][i1].state = 0;   // 左へ
							else
								friend[0][i1].state = -1;   // 上へ
						}
						else {
							if (Map.map[k1][k2] == 0) {
								friend[0][i1].y = k1 * Map.block_height;
								friend[0][i1].state = 0;   // 右へ
							}
							else if (Map.map[k1+1][k2+1] > 0)
								friend[0][i1].state = -1;   // 上へ
						}
					}
									// 衝突判定
					if (f_state[0][i1] > 0) {
						int k1 = (int)(friend[0][i1].y / Map.block_height);
						int k2 = (int)(friend[0][i1].x / Map.block_width);
						for (int i2 = 0; i2 < e_state.length; i2++) {
							if (e_state[i2] > 0) {
								int t1 = (int)(enemy[i2].y / Map.block_height);
								int t2 = (int)(enemy[i2].x / Map.block_width);
								if (k1 == t1 && k2 == t2) {
									e_state[i2] = -1;
									n_e_now_ex--;
									if (n_e_now_ex == 0) {
										sw = -1;
										in_game  = false;
										mp.state = 2;   // ゲームクリア
									}
								}
							}
						}
					}
				}
			}
							// 味方２との衝突判定
			for (int i1 = 0; i1 < f_state[1].length; i1++) {
				if (f_state[1][i1] > 0) {
					int k1 = (int)(friend[1][i1].y / Map.block_height);
					int k2 = (int)(friend[1][i1].x / Map.block_width);
					for (int i2 = 0; i2 < e_state.length; i2++) {
						if (e_state[i2] > 0) {
							int t1 = (int)(enemy[i2].y / Map.block_height);
							int t2 = (int)(enemy[i2].x / Map.block_width);
							if (Math.abs(k1-t1) + Math.abs(k2-t2) <= 2) {
								e_state[i2] = -1;
								n_e_now_ex--;
								if (n_e_now_ex == 0) {
									sw = -1;
									in_game  = false;
									mp.state = 2;   // ゲームクリア
								}
							}
						}
					}
				}
			}
					// 敵の位置
			for (int i1 = 0; i1 < e_state.length; i1++) {
				if (e_state[i1] > 0) {
							// 敵１
					if (enemy[i1].type == 0) {
									// 右へ移動
						if (enemy[i1].state == 0) {
							enemy[i1].x += enemy[i1].v;
							int k2 = (int)((enemy[i1].x + Map.block_width) / Map.block_width);
							if (k2 >= Map.map_col)
								sw = 1;
							else {
								int k1 = (int)(enemy[i1].y / Map.block_height);
								if (Map.map[k1][k2] > 0) {
									enemy[i1].x = (k2 - 1) * Map.block_width;
									double r = Math.random();
									if (k1 == Map.map_row-1 && Map.map[k1-1][k2-1] == 0 || k1 > 0 && k1 < Map.map_row-1 && (Map.map[k1+1][k2-1] > 0 || r > 0.5 && Map.map[k1+1][k2-1] == 0 && Map.map[k1-1][k2-1] == 0))
										enemy[i1].state = -1;   // 上へ
									else if (k1 == 0 && Map.map[k1+1][k2-1] == 0 || k1 > 0 && k1 < Map.map_row-1 && (Map.map[k1-1][k2-1] > 0 || r <= 0.5 && Map.map[k1+1][k2-1] == 0 && Map.map[k1-1][k2-1] == 0))
										enemy[i1].state = 1;   // 下へ
								}
							}
						}
									// 上へ移動
						else if (enemy[i1].state < 0) {
							enemy[i1].y -= enemy[i1].v;
							int k1 = (int)((enemy[i1].y + Map.block_height) / Map.block_height);
							int k2 = (int)(enemy[i1].x / Map.block_width) + 1;
							if (Map.map[k1][k2] == 0) {
								enemy[i1].y = k1 * Map.block_height;
								enemy[i1].state = 0;   // 右へ
							}
							else if (k1 == 0 || Map.map[k1-1][k2-1] > 0)
								enemy[i1].state = 1;   // 下へ
						}
									// 下へ移動
						else {
							enemy[i1].y += enemy[i1].v;
							int k1 = (int)(enemy[i1].y / Map.block_height);
							int k2 = (int)(enemy[i1].x / Map.block_width) + 1;
							if (k1 >= Map.map_row-1) {
								enemy[i1].y = k1 * Map.block_height;
								if (Map.map[k1][k2] == 0)
									enemy[i1].state = 0;   // 右へ
								else
									enemy[i1].state = -1;   // 上へ
							}
							else {
								if (Map.map[k1][k2] == 0) {
									enemy[i1].y = k1 * Map.block_height;
									enemy[i1].state = 0;   // 右へ
								}
								else if (Map.map[k1+1][k2-1] > 0)
									enemy[i1].state = -1;   // 上へ
							}
						}
					}
							// 敵２
					else if (enemy[i1].type == 1) {
						enemy[i1].x += enemy[i1].v;
						int k2 = (int)((enemy[i1].x + Map.block_width) / Map.block_width);
						if (k2 >= Map.map_col)
							sw = 1;
					}
							// ゲームオーバーか否か
					if (sw > 0) {
						in_game  = false;
						mp.state = 3;   // ゲームオーバー
					}
				}
			}
					// 次の敵
			count++;
			if (count == next_time) {
				n_e_now--;
				count = 0;
				e_state[next] = 1;
				if (n_e_now > 0) {
					next_time = (int)(5 * 30 - 30 * rn.nextDouble());
					next = -1;
					while (next < 0) {
						next = (int)(e_state.length * rn.nextDouble());
						if (next >= e_state.length)
							next = e_state.length - 1;
						if (e_state[next] != 0)
							next = -1;
					}
				}
				else
					next_time = -1;
			}
					// 再描画
			if (sw == 0)
				repaint();
		}
	}
			// 描画
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);   // 親クラスの描画
					// 背景の描画
		for (int i1 = 0; i1 < Map.map_col; i1++) {
			int x = i1 * Map.block_width;
			for (int i2 = 0; i2 < Map.map_row; i2++) {
				if (Map.map[i2][i1] > 0) {
					int y = i2 * Map.block_height;
					g.drawImage(Map.block_image[Map.map[i2][i1]-1], x, y, Map.block_width, Map.block_height, this);
				}
			}
		}
					// マーカーの描画
		g.drawImage(mark, mark_x, mark_y, Map.block_width, Map.block_height, this);
					// 味方の描画
		for (int i1 = 0; i1 < mp.n_friend.length; i1++) {
			for (int i2 = 0; i2 < f_state[i1].length; i2++) {
				if (f_state[i1][i2] > 0)
					g.drawImage(friend[i1][i2].image, friend[i1][i2].x, friend[i1][i2].y, Map.block_width, Map.block_height, this);
			}
		}
					// 敵の描画
		for (int i1 = 0; i1 < e_state.length; i1++) {
			if (e_state[i1] > 0)
				g.drawImage(enemy[i1].image, enemy[i1].x, enemy[i1].y, Map.block_width, Map.block_height, this);
		}
					// この Component が入力フォーカスを取得することを要求
		requestFocusInWindow();
	}
			// マウスイベントの処理
	class Mouse extends MouseAdapter {
		public void mousePressed(MouseEvent e) {
			int k1 = e.getY() / Map.block_height;
			int k2 = e.getX() / Map.block_width;
			if (k1 >= 0 && k1 < Map.map_row && k2 >= 0 && k2 < Map.map_col && Map.map[k1][k2] == 0) {
				mark_x = k2 * Map.block_width;
				mark_y = k1 * Map.block_height;
				mouse = true;
			}
		}
	}
			// キーイベントの処理
	class Key extends KeyAdapter {
		public void keyPressed(KeyEvent e)
		{
			if(mouse && e.getKeyCode() >= 49 && e.getKeyCode() <= 51) {
				if (e.getKeyCode() == 49) {   // キー 1
					if (mp.n_friend[0] > 0) {
						mp.n_friend[0]--;
						f_state[0][mp.n_friend[0]] = 1;
						friend[0][mp.n_friend[0]].x = mark_x;
						friend[0][mp.n_friend[0]].y = mark_y;
					}
				}
				else if (e.getKeyCode() == 50) {   // キー 2
					if (mp.n_friend[1] > 0) {
						mp.n_friend[1]--;
						f_state[1][mp.n_friend[1]] = 1;
						friend[1][mp.n_friend[1]].x = mark_x;
						friend[1][mp.n_friend[1]].y = mark_y;
					}
				}
				mark_x = 0;
				mark_y = 0;
				mouse = false;
			}
		}
	}
}
