gp = null;   // GamePanel オブジェクト

			//
			// GamePanel の開始
			//
function gp_start()
{
					// GamePanel オブジェクト
	gp = new GamePanel();
					// タイマーのスタート
	gp.timerID = setInterval('gp.draw()', 30);
					// マウスリスナの追加（マウスボタンが押された時）
	mp.canvas.addEventListener("mousedown", gp.onMouseDown);
					// ボタンの表示制御
	document.getElementById('method').style.display = "none";
	document.getElementById('start').style.display = "none";
	document.getElementById('first').style.display = "none";
	document.getElementById('finish').style.display = "none";
}
			//
			// GamePanel オブジェクト（プロパティ）
			//
function GamePanel()
{
	this.timerID = -1;
	this.rd = new Road();   // Road オブジェクト
	this.hr = new Hero(this.rd);   // Hero オブジェクト
	return this;
}
			//
			// GamePanel オブジェクト（メソッド draw）
			//
GamePanel.prototype.draw = function()
{
					// キャンバスのクリア
	mp.ctx.clearRect(0, 0, mp.canvas.width, mp.canvas.height);
					// 移動
	gp.rd.x += gp.rd.v_x;
	gp.hr.x += gp.hr.v_x;
					// 主人公の描画
	mp.ctx.drawImage(gp.hr.image, gp.hr.x, gp.hr.y);
					// 背景の描画
	for (let i1 = 0; i1 < gp.rd.col; i1++) {
		let x = gp.rd.x + gp.rd.width * i1;
		if (x + gp.rd.width >= 0 && x <= mp.canvas.width) {
			for (let i2 = 0; i2 < gp.rd.row; i2++) {
				if (gp.rd.blk[i2][i1] > 0) {
					let y = i2 * gp.rd.height;
					mp.ctx.drawImage(gp.rd.image[gp.rd.blk[i2][i1]-1], x, y);
				}
			}
		}
	}
}
			//
			// GamePanel オブジェクト（メソッド onMouseDown）
			//
GamePanel.prototype.onMouseDown = function(event)
{
	clearInterval(gp.timerID);   // タイマーの停止
	gcp_start();
}
			//
			// Road オブジェクト（プロパティ）
			//
function Road()
{
					// レベル１における画像の配置
	this.blk1 = new Array();
	this.blk1[0] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk1[1] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk1[2] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk1[3] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk1[4] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk1[5] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk1[6] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk1[7] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk1[8] = new Array(1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2);
	this.blk1[9] = new Array(1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2);
	this.blk1[10] = new Array(1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2);
	this.blk1[11] = new Array(1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2);
					// レベル２における画像の配置
	this.blk2 = new Array();
	this.blk2[0] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk2[1] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk2[2] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk2[3] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk2[4] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk2[5] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk2[6] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk2[7] = new Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
	this.blk2[8] = new Array(1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 2, 2, 2);
	this.blk2[9] = new Array(1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 2, 2, 2);
	this.blk2[10] = new Array(1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 2, 2, 2);
	this.blk2[11] = new Array(1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 2, 2, 2);
	this.blk = new Array();   // 背景を構成するブロック
	this.image = new Array();   // ブロック画像
	this.row = 12;   // ブロックの行数
	this.col;   // ブロックの列数
	this.r_no = 4;   // 道を構成する縦のブロック数
	this.x = 0;   // 背景の位置
	this.v_x = -2;   // 背景の水平方向移動速度
	this.width = 25;   // ブロックの幅
	this.height = 25;   // ブロックの高さ
					// ブロック画像の読み込み
	this.image[0] = new Image();
	this.image[0].src = "image/road1.jpg";
	this.image[1] = new Image();
	this.image[1].src = "image/road2.jpg";
					// レベルによる初期設定
	if (mp.level == 1) {
		this.col = 26;
		this.blk = this.blk1;
	}
	else {
		this.col = 23;
		this.blk = this.blk2;
	}
	return this;
}
			//
			// Hero オブジェクト（プロパティ）
			//
function Hero(rd)
{
	this.image = new Image();   // 主人公
	this.v_x = 1.0;   // 主人公の水平方向移動速度
	this.width = 32;   // 主人公の幅
	this.height = 52;   // 主人公の高さ
					// 主人公の読み込み
	this.image.src = "image/char.jpg";
					// 主人公の初期位置
	this.x = 0;
	this.y = mp.canvas.height - rd.height * rd.r_no - this.height;
	return this;
}
