gp = null;   // GamePanel オブジェクト

			//
			// GamePanel の開始
			//
function gp_start()
{
					// GamePanel オブジェクト
	gp = new GamePanel();
					// タイマーのスタート
	gp.timerID = setInterval('gp.draw()', 30);
					// マウスリスナの追加（マウスボタンが押された時と離された時）
	mp.canvas.addEventListener("mousedown", gp.onMouseDown);
	mp.canvas.addEventListener("touchstart", gp.onMouseDown);
	mp.canvas.addEventListener("touchmove", gp.onMouseDown);
	mp.canvas.addEventListener("mouseup", gp.onMouseUp);
					// ボタンの表示制御
	document.getElementById('method').style.display = "none";
	document.getElementById('start').style.display = "none";
	document.getElementById('first').style.display = "none";
	document.getElementById('finish').style.display = "none";
}
			//
			// GamePanel オブジェクト（プロパティ）
			//
function GamePanel()
{
	this.timerID = -1;
	this.rd = new Road();   // Road オブジェクト
	this.hr = new Hero(this.rd);   // Hero オブジェクト
	return this;
}
			//
			// GamePanel オブジェクト（メソッド draw）
			//
GamePanel.prototype.draw = function()
{
					// キャンバスのクリア
	mp.ctx.clearRect(0, 0, mp.canvas.width, mp.canvas.height);
					// 移動
	gp.rd.x += gp.rd.v_x;
	gp.hr.v_y += (gp.hr.up - gp.hr.down);
	gp.hr.x += gp.hr.v_x;
	gp.hr.y -= gp.hr.v_y;
					// 描画
	mp.ctx.drawImage(gp.rd.image, gp.rd.x, gp.rd.y);
	mp.ctx.drawImage(gp.hr.image, gp.hr.x, gp.hr.y);
					// 状態のチェック
							// 水平位置のチェック
	let p  = gp.hr.x - gp.rd.x + gp.hr.width / 2;
	let sw = -1;
	for (let i1 = 0; i1 < gp.rd.state.length && sw < 0; i1++) {
		if (p <= gp.rd.state[i1][0])
			sw = gp.rd.state[i1][1];
	}
	if (sw < 0)   // ゴールを通過
		sw = 1;
							// 垂直位置のチェック
	else {
		if (gp.hr.jump) {
			if (gp.hr.y >= mp.canvas.height - gp.rd.height - gp.hr.height) {
				if (sw == 0 || sw == 10) {
					gp.hr.jump = false;
					gp.hr.down = 0.0;
					gp.hr.v_x  = 1.0;
					gp.hr.v_y  = 0.0;
					gp.hr.y    = mp.canvas.height - gp.rd.height - gp.hr.height;
				}
			}
			else
				sw = 0;
		}
	}
							// ゲーム状態変更
	if (sw > 0) {
		clearInterval(gp.timerID);   // タイマーの停止
		if (sw == 1)
			gop_start();   // ゲームオーバー
		else
			gcp_start();   // ゲームクリア
	}
}
			//
			// GamePanel オブジェクト（メソッド onMouseDown）
			//
GamePanel.prototype.onMouseDown = function(event)
{
	if (!gp.hr.jump) {
		gp.hr.up   = 1.0;
		gp.hr.down = 0.5;
		gp.hr.v_x  = 2.0;
		gp.hr.jump = true;
		gp.hr.y--;   // 着地判定のため，1 ピクセルだけジャンプさせておく
	}
}
			//
			// GamePanel オブジェクト（メソッド onMouseUp）
			//
GamePanel.prototype.onMouseUp = function(event)
{
	gp.hr.up   = 0.0;
	gp.hr.down = 0.5;
}
			//
			// Road オブジェクト（プロパティ）
			//
function Road()
{
	this.image = new Image();   // 背景
	this.v_x = -2.0;   // 背景の水平方向移動速度
	this.width = (mp.level == 1) ? 643 : 557;   // 背景画像の幅
	this.height = 102;   // 背景画像の高さ
	this.s1 = new Array()
	this.s1[0] = new Array(147, 0);
	this.s1[1] = new Array(204, 1);
	this.s1[2] = new Array(352, 0);
	this.s1[3] = new Array(494, 1);
	this.s1[4] = new Array(642, 10);
	this.s2 = new Array();
	this.s2[0] = new Array(73, 0);
	this.s2[1] = new Array(139, 1);
	this.s2[2] = new Array(213, 0);
	this.s2[3] = new Array(330, 1);
	this.s2[4] = new Array(404, 0);
	this.s2[5] = new Array(482, 1);
	this.s2[6] = new Array(556, 10);
	this.state = null;   // 背景（道）の状態
	                     //   state[i][0] : 状態変化の終了位置
	                     //   state[i][1] : 道の状態
	                     //                   =0 : 道
	                     //                   =1 : 谷
	                     //                   =10 : ゴール
					// 背景の読み込みと状態設定
	if (mp.level == 1) {
		this.image.src = "image/road1.jpg";
		this.state = this.s1;
	}
	else {
		this.image.src = "image/road2.jpg";
		this.state = this.s2;
	}
					// 背景の初期位置
	this.x = 0;
	this.y = mp.canvas.height - this.height;
	return this;
}
			//
			// Hero オブジェクト（プロパティ）
			//
function Hero(rd)
{
	this.image = new Image();   // 主人公
	this.v_x = 1.0;   // 主人公の水平方向移動速度
	this.v_y = 0.0;   // 主人公の垂直方向移動速度
	this.up = 0.0;   // 主人公の上向き加速度
	this.down = 0;   // 主人公の下向き加速度
	this.jump = false;   // 主人公がジャンプ中か？
	this.width = 32;   // 主人公の幅
	this.height = 52;   // 主人公の高さ
					// 主人公の読み込み
	this.image.src = "image/char.jpg";
					// 背景の初期位置
	this.x = 0;
	this.y = mp.canvas.height - rd.height - this.height;
	return this;
}
