gp = null;   // GamePanel オブジェクト

			//
			// GamePanel の開始
			//
function gp_start()
{
					// GamePanel オブジェクト
	gp = new GamePanel();
					// タイマーのスタート
	gp.timerID = setInterval('gp.draw()', 50);
					// ボタンの表示制御
	document.getElementById('method').style.display = "none";
	document.getElementById('start').style.display = "none";
	document.getElementById('first').style.display = "none";
	document.getElementById('finish').style.display = "none";
	document.getElementById('left').style.display = "";
	document.getElementById('right').style.display = "";
}
			//
			// GamePanel オブジェクト（プロパティ）
			//
function GamePanel()
{
	this.timerID = -1;
	this.blk = new Block();   // Block オブジェクト
	this.rk = new Racket();   // Racket オブジェクト
	this.bl = new Ball(this.blk);   // Ball オブジェクト
	return this;
}
			//
			// GamePanel オブジェクト（メソッド draw）
			//
GamePanel.prototype.draw = function()
{
					// キャンバスのクリア
	mp.ctx.clearRect(0, 0, mp.canvas.width, mp.canvas.height);
					// 描画
							// ブロック
	for (let i1 = 0; i1 < gp.blk.row; i1++) {
		for (let i2 = 0; i2 < gp.blk.col; i2++) {
			if (gp.blk.ex[i1][i2])
				mp.ctx.drawImage(gp.blk.block, gp.blk.width*i2, gp.blk.height*i1);
		}
	}
							// ラケット
	mp.ctx.beginPath();
	mp.ctx.fillStyle = "rgb(0, 255, 0)";
	mp.ctx.fillRect(gp.rk.x, gp.rk.y, gp.rk.width, gp.rk.height);
	mp.ctx.fill();
							// ボール
	mp.ctx.beginPath();
	mp.ctx.fillStyle = "rgb(255, 0, 0)";
	mp.ctx.arc(gp.bl.x, gp.bl.y, gp.bl.r, 0, 2*Math.PI);
	mp.ctx.fill();
					// 移動
	gp.bl.x += gp.bl.vx;
	gp.bl.y += gp.bl.vy;
}
			//
			// GamePanel オブジェクト（メソッド move）
			//
GamePanel.prototype.move = function(sw)
{
	clearInterval(gp.timerID);   // タイマーの停止
	if (sw == 0)
		gcp_start();
	else
		gop_start();
}
			//
			// Block オブジェクト（プロパティ）
			//
function Block()
{
	this.block = new Image();   // ブロックの画像
	this.width = 75;   // ブロックの幅
	this.height = 38;   // ブロックの高さ
	this.row = 2;   // ブロックの行数
	this.col = 4;   // ブロックの列数
	this.number = this.row * this.col;   // ブロックの数
	this.ex = new Array();   // ブロックの状態（存在するか否か）
	for (let i1 = 0; i1 < this.row; i1++) {
		this.ex[i1] = new Array();
		for (let i2 = 0; i2 < this.col; i2++)
			this.ex[i1][i2] = true;
	}
					// ブロック画像の読み込み
	this.block.src = "image/block.jpg";
	return this;
}
			//
			// Racket オブジェクト（プロパティ）
			//
function Racket()
{
	this.width;   // ラケットの幅
	this.height = 20;   // ラケットの高さ
	this.x;   // ラケットの横位置
	this.y;   // ラケットの縦位置
					// 幅と位置の設定
	if (mp.level == 1)
		this.width = 80;
	else
		this.width = 40;
	this.x = mp.canvas.width / 2 - this.width / 2;
	this.y = mp.canvas.height - this.height;
	return this;
}
			//
			// Ball オブジェクト（プロパティ）
			//
function Ball(blk)
{
	this.r = 7;   // ボールの半径
	this.x;   // ボールの横位置
	this.y;   // ボールの縦位置
	this.vx;   // ボールの横方向速度成分
	this.vy;   // ボールの縦方向速度成分
					// 位置と速度の設定
	this.x  = this.r + Math.floor(Math.random() * (mp.canvas.width - 2 * this.r));
	this.y  = blk.height * blk.row + 10;
	this.vx = 0;
	this.vy = 0;
	return this;
}
