gp = null;   // GamePanel オブジェクト

			//
			// GamePanel の開始
			//
function gp_start()
{
					// GamePanel オブジェクト
	gp = new GamePanel();
					// 描画
	gp.draw();
					// マウスクリックに対するイベントリスナ
	mp.canvas.addEventListener("click", gp.mouseClick);
					// ボタンの表示制御
	document.getElementById('method').style.display = "none";
	document.getElementById('g_method0').style.display = "none";
	document.getElementById('g_method1').style.display = "none";
	document.getElementById('g_method2').style.display = "none";
	document.getElementById('ta').style.display = "";
	document.getElementById('ta').style.color = "black";
	document.getElementById('ta').innerHTML = "黒の番です．";
	document.getElementById('first').style.display = "";
	document.getElementById('finish').style.display = "";
}
			//
			// GamePanel オブジェクト（プロパティ）
			//
function GamePanel()
{
	this.sz = 51;   // マス目の大きさ
	this.gap = 3;   // マス目間のギャップ
	this.b_w = -1;   // -1:黒の手番，1:白の手番
	this.st = new Array();   // 盤面の状態（0:コマが置かれてない，-1:黒，1:白）
	this.st[0] = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	this.st[1] = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	this.st[2] = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	this.st[3] = new Array(0, 0, 0, 1, -1, 0, 0, 0);
	this.st[4] = new Array(0, 0, 0, -1, 1, 0, 0, 0);
	this.st[5] = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	this.st[6] = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	this.st[7] = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	this.n = new Array();   // 指定された位置の各方向に対する反転できるコマの数
	                        //    [0] : 上方向
	                        //    [1] : 斜め右上方向
	                        //    [2] : 右方向
	                        //    [3] : 斜め右下方向
	                        //    [4] : 下方向
	                        //    [5] : 斜め左下方向
	                        //    [6] : 左方向
	                        //    [7] : 斜め左上方向
	                        //    [8] : 全体
	return this;
}
			//
			// GamePanel オブジェクト（メソッド mouseClick）
			//
GamePanel.prototype.mouseClick = function(event)
{
	let x_base  = mp.canvas.offsetLeft;   // キャンバスの左上のｘ座標
	let y_base  = mp.canvas.offsetTop;   // キャンバスの左上のｙ座標
	let x       = event.pageX - x_base;    // キャンバス内のクリックされた位置（ｘ座標）
	let y       = event.pageY - y_base;    // キャンバス内のクリックされた位置（ｙ座標）
					// クリックされたマス目を特定
	let k = new Array(-1, -1);
	for (let i1 = 0; i1 < 8; i1++) {
		if (y >= gp.gap+i1*(gp.gap+gp.sz) && y <= (i1+1)*(gp.gap+gp.sz)) {
			k[0] = i1;
			break;
		}
	}
	for (let i1 = 0; i1 < 8; i1++) {
		if (x >= gp.gap+i1*(gp.gap+gp.sz) && x <= (i1+1)*(gp.gap+gp.sz)) {
			k[1] = i1;
			break;
		}
	}
					// 反転できるコマを探す
	gp.r_check(k);
							// 反転するコマがない場合
	if (gp.n[8] <= 0) {
		document.getElementById('ta').style.color = "red";
		let str = "の番ですが，\nそこへはコマを置けません．";
		if (gp.b_w < 0)
			document.getElementById('ta').innerHTML = "黒" + str;
		else
			document.getElementById('ta').innerHTML = "白" + str;
	}
							// 反転するコマがある場合
	else
		gp.set(k);
}
			//
			// k[0] 行 k[1] 列に黒または白（ b_w ）のコマを置いた場合，反転できるコマを探す
			//
GamePanel.prototype.r_check = function(k)
{
	let d = new Array();
	d[0] = new Array(-1, 0);
	d[1] = new Array(-1, 1);
	d[2] = new Array(0, 1);
	d[3] = new Array(1, 1);
	d[4] = new Array(1, 0);
	d[5] = new Array(1, -1);
	d[6] = new Array(0, -1);
	d[7] = new Array(-1, -1);
	gp.n[8] = 0;
	if (k[0] >= 0 && k[1] >= 0 && gp.st[k[0]][k[1]] == 0) {
		for (let i1 = 0; i1 < 8; i1++) {
			let m1   = k[0];
			let m2   = k[1];
			gp.n[i1] = 0;
			let s    = 0;   // 0:開始，1:カウント，2:カウント終了，3:反転不可能
			let ct   = 0;
			while (s < 2) {
				m1 += d[i1][0];
				m2 += d[i1][1];
				if (m1 >= 0 && m1 < 8 && m2 >= 0 && m2 < 8) {
					if (gp.st[m1][m2] == 0)
						s = 3;
					else if (gp.st[m1][m2] == gp.b_w) {
						if (s == 1)
							s = 2;
						else
							s = 3;
					}
					else {
						s = 1;
						ct++;
					}
				}
				else
					s = 3;
			}
			if (s == 2) {
				gp.n[8]  += ct;
				gp.n[i1]  = ct;
			}
		}
	}
}
			//
			// コマの操作
			//
GamePanel.prototype.set = function(k)
{
					// 反転
	gp.reverse(k);
	gp.b_w = -gp.b_w;
	document.getElementById('ta').style.color = "black";
	if (gp.b_w < 0)
		document.getElementById('ta').innerHTML = "黒の番です．";
	else
		document.getElementById('ta').innerHTML = "白の番です．";
}
			//
			// k[0] 行 k[1] 列に黒または白（ b_w ）のコマを置いた場合におけるコマの反転
			//
GamePanel.prototype.reverse = function(k)
{
	let d = new Array();
	d[0] = new Array(-1, 0);
	d[1] = new Array(-1, 1);
	d[2] = new Array(0, 1);
	d[3] = new Array(1, 1);
	d[4] = new Array(1, 0);
	d[5] = new Array(1, -1);
	d[6] = new Array(0, -1);
	d[7] = new Array(-1, -1);
	for (let i1 = 0; i1 < 8; i1++) {
		let m1   = k[0];
		let m2   = k[1];
		for (let i2 = 0; i2 < gp.n[i1]; i2++) {
			m1 += d[i1][0];
			m2 += d[i1][1];
			gp.st[m1][m2] = gp.b_w;
		}
	}
	gp.st[k[0]][k[1]] = gp.b_w;
					// 描画
	gp.draw();
}
			//
			// GamePanel オブジェクト（メソッド draw）
			//
GamePanel.prototype.draw = function()
{
					// キャンバスのクリア
	mp.ctx.clearRect(0, 0, mp.canvas.width, mp.canvas.height);
					// 描画
	mp.ctx.beginPath();
	mp.ctx.fillStyle = "rgb(165, 42, 42)";
	mp.ctx.fillRect(0, 0, mp.canvas.width, mp.canvas.height);
	mp.ctx.fill();

	for (let i1 = 0; i1 < 8; i1++) {
		for (let i2 = 0; i2 < 8; i2++) {
			let x = gp.gap + i2 * (gp.sz + gp.gap);
			let y = gp.gap + i1 * (gp.sz + gp.gap);
			mp.ctx.beginPath();
			mp.ctx.fillStyle = "rgb(0, 255, 0)";
			mp.ctx.fillRect(x, y, gp.sz, gp.sz);
			mp.ctx.fill();
			if (gp.st[i1][i2] != 0) {
				x += Math.floor(gp.sz / 2);
				y += Math.floor(gp.sz / 2);
				mp.ctx.beginPath();
				if (gp.st[i1][i2] < 0)
					mp.ctx.fillStyle = "rgb(0, 0, 0)";
				else
					mp.ctx.fillStyle = "rgb(255, 255, 255)";
				mp.ctx.arc(x, y, Math.floor(gp.sz/2)-2, 0, 2*Math.PI);
				mp.ctx.fill();
			}
		}
	}
}
