gp = null;   // GamePanel オブジェクト

			//
			// GamePanel の開始
			//
function gp_start()
{
					// GamePanel オブジェクト
	gp = new GamePanel();
					// ピースの選択
	gp.py.select();
	gp.py.draw();
					// タイマーのスタート
	gp.timerID = setInterval('gp.py.drop()', 500);
					// ボタンの表示制御
	document.getElementById('method').style.display = "none";
	document.getElementById('start').style.display = "none";
	document.getElementById('finish').style.display = "none";
	document.getElementById('rot').style.display = "";
	document.getElementById('left').style.display = "";
	document.getElementById('right').style.display = "";
	document.getElementById('color').style.display = "";
}
			//
			// GamePanel オブジェクト（プロパティ）
			//
function GamePanel()
{
	this.timerID = -1;
	this.in_game = true;   // ゲーム中か否か
	this.py = new Puyo();
	return this;
}
			//
			// Puyo オブジェクト（プロパティ）
			//
function Puyo()
{
	this.p_x;   // 左または上のピースの座標（横）
	this.p_y;   // 左または上のピースの座標（縦）
	this.row = 12;   // ゲーム画面の行数
	this.col = 5;   // ゲーム画面の列数
	this.width = 30;   // ピースの幅と高さ
	this.rot;   // 0:横，1:縦
	this.p = new Array();   // 画面の状態（0:存在しない，1:赤，2:ピンク，3:緑，4:青）
	for (let i1 = 0; i1 < this.row; i1++) {
		this.p[i1] = new Array();
		for (let i2 = 0; i2 < this.col; i2++)
			this.p[i1][i2] = 0;
	}
	this.color = new Array("rgb(255,0,0)", "rgb(255,192,203)",
	                       "rgb(0,255,0)", "rgb(0,0,255)");   // ピースの色
	this.ok = true;   // 移動，回転，色の交換が可能か？
	return this;
}
			//
			// Puyo オブジェクト（メソッド drop）
			//
Puyo.prototype.drop = function()
{
					// ピースの落下
	let ct = 0;
							// 横
	if (gp.py.rot == 0) {
		if (gp.py.p_y < gp.py.row-1) {
			ct = 1;
			gp.py.p[gp.py.p_y+1][gp.py.p_x]   = gp.py.p[gp.py.p_y][gp.py.p_x];
			gp.py.p[gp.py.p_y+1][gp.py.p_x+1] = gp.py.p[gp.py.p_y][gp.py.p_x+1];
			gp.py.p[gp.py.p_y][gp.py.p_x]     = 0;
			gp.py.p[gp.py.p_y][gp.py.p_x+1]   = 0;
			gp.py.p_y++;
		}
		else
			gp.py.ok = false;
	}
							// 縦
	else {
		if (gp.py.p_y < gp.py.row-2) {
			ct = 1;
			gp.py.p[gp.py.p_y+2][gp.py.p_x] = gp.py.p[gp.py.p_y+1][gp.py.p_x];
			gp.py.p[gp.py.p_y+1][gp.py.p_x] = gp.py.p[gp.py.p_y][gp.py.p_x];
			gp.py.p[gp.py.p_y][gp.py.p_x]   = 0;
			gp.py.p_y++;
		}
		else
			gp.py.ok = false;
	}
					// 次のピース
	if (ct == 0)
		gp.py.select();
					// 再描画
	if (gp.in_game)
		gp.py.draw();
}
			//
			// Puyo オブジェクト（メソッド select）
			//
Puyo.prototype.select = function()
{
	gp.py.ok  = true;
	gp.py.rot = 0;
	gp.py.p_y = 0;
	gp.py.p_x = Math.floor((gp.py.col - 1) * Math.random());
	gp.py.p[0][gp.py.p_x]   = 1 + Math.floor(4 * Math.random());
	gp.py.p[0][gp.py.p_x+1] = 1 + Math.floor(4 * Math.random());
}
			//
			// Puyo オブジェクト（メソッド draw）
			//
Puyo.prototype.draw = function()
{
					// キャンバスのクリア
	mp.ctx.clearRect(0, 0, mp.canvas.width, mp.canvas.height);
					// 描画
	for (let i1 = 0; i1 < gp.py.row; i1++) {
		for (let i2 = 0; i2 < gp.py.col; i2++) {
			if (gp.py.p[i1][i2] > 0) {
				mp.ctx.beginPath();
				mp.ctx.fillStyle = gp.py.color[gp.py.p[i1][i2]-1];
				mp.ctx.fillRect(i2*gp.py.width, i1*gp.py.width, gp.py.width, gp.py.width);
				mp.ctx.fill();
			}
		}
	}
}
			//
			// Puyo オブジェクト（メソッド operation）
			//
Puyo.prototype.operation = function(sw)
{
	if (gp.py.ok) {
		switch (sw) {
					// 左移動
			case 0:
				if (gp.py.p_x > 0) {
					if (gp.py.rot == 0 && gp.py.p[gp.py.p_y][gp.py.p_x-1] == 0) {
						gp.py.p[gp.py.p_y][gp.py.p_x-1] = gp.py.p[gp.py.p_y][gp.py.p_x];
						gp.py.p[gp.py.p_y][gp.py.p_x]   = gp.py.p[gp.py.p_y][gp.py.p_x+1];
						gp.py.p[gp.py.p_y][gp.py.p_x+1] = 0;
						gp.py.p_x--;
					}
					else if (gp.py.p[gp.py.p_y][gp.py.p_x-1] == 0 && gp.py.p[gp.py.p_y+1][gp.py.p_x-1] == 0) {
						gp.py.p[gp.py.p_y][gp.py.p_x-1]   = gp.py.p[gp.py.p_y][gp.py.p_x];
						gp.py.p[gp.py.p_y+1][gp.py.p_x-1] = gp.py.p[gp.py.p_y+1][gp.py.p_x];
						gp.py.p[gp.py.p_y][gp.py.p_x]     = 0;
						gp.py.p[gp.py.p_y+1][gp.py.p_x]   = 0;
						gp.py.p_x--;
					}
				}
				break;
					// 右移動
			case 1:
				if (gp.py.rot == 0) {
					if (gp.py.p_x < gp.py.col-2 && gp.py.p[gp.py.p_y][gp.py.p_x+2] == 0) {
						gp.py.p[gp.py.p_y][gp.py.p_x+2] = gp.py.p[gp.py.p_y][gp.py.p_x+1];
						gp.py.p[gp.py.p_y][gp.py.p_x+1] = gp.py.p[gp.py.p_y][gp.py.p_x];
						gp.py.p[gp.py.p_y][gp.py.p_x]   = 0;
						gp.py.p_x++;
					}
				}
				else {
					if (gp.py.p_x < gp.py.col-1 && gp.py.p[gp.py.p_y][gp.py.p_x+1] == 0 && gp.py.p[gp.py.p_y+1][gp.py.p_x+1] == 0) {
						gp.py.p[gp.py.p_y][gp.py.p_x+1]   = gp.py.p[gp.py.p_y][gp.py.p_x];
						gp.py.p[gp.py.p_y+1][gp.py.p_x+1] = gp.py.p[gp.py.p_y+1][gp.py.p_x];
						gp.py.p[gp.py.p_y][gp.py.p_x]     = 0;
						gp.py.p[gp.py.p_y+1][gp.py.p_x]   = 0;
						gp.py.p_x++;
					}
				}
				break;
					// 上下または左右入れ替え
			case 2:
				if (gp.py.rot == 0) {
					let k = gp.py.p[gp.py.p_y][gp.py.p_x];
					gp.py.p[gp.py.p_y][gp.py.p_x]   = gp.py.p[gp.py.p_y][gp.py.p_x+1];
					gp.py.p[gp.py.p_y][gp.py.p_x+1] = k;
				}
				else {
					let k = gp.py.p[gp.py.p_y][gp.py.p_x];
					gp.py.p[gp.py.p_y][gp.py.p_x]   = gp.py.p[gp.py.p_y+1][gp.py.p_x];
					gp.py.p[gp.py.p_y+1][gp.py.p_x] = k;
				}
				break;
					// 90度または-90度回転
			case 3:
				if (gp.py.rot == 0 && gp.py.p[gp.py.p_y+1][gp.py.p_x] == 0) {
					if (gp.py.p_y < gp.py.row-1) {
						gp.py.p[gp.py.p_y+1][gp.py.p_x] = gp.py.p[gp.py.p_y][gp.py.p_x+1];
						gp.py.p[gp.py.p_y][gp.py.p_x+1] = 0;
						gp.py.rot = 1;
					}
				}
				else {
					if (gp.py.p_x < gp.py.col-1 && gp.py.p[gp.py.p_y][gp.py.p_x+1] == 0) {
						gp.py.p[gp.py.p_y][gp.py.p_x+1] = gp.py.p[gp.py.p_y+1][gp.py.p_x];
						gp.py.p[gp.py.p_y+1][gp.py.p_x] = 0;
						gp.py.rot = 0;
					}
				}
				break;
		}
					// 再描画
		if (gp.in_game)
			gp.py.draw();
	}
}
