gp = null;   // GamePanel オブジェクト

			//
			// GamePanel の開始
			//
function gp_start()
{
					// GamePanel オブジェクト
	gp = new GamePanel();
					// タイマーのスタート
	gp.timerID = setInterval('gp.timer()', 10);
					// キーリスナの追加（キーが押された時）
	mp.canvas.addEventListener("keydown", gp.onKeyDown, false);
	mp.canvas.focus();
					// ボタンの表示制御
	document.getElementById('method').style.display = "none";
	document.getElementById('start').style.display = "none";
	document.getElementById('first').style.display = "none";
	document.getElementById('finish').style.display = "none";
	document.getElementById('clear').style.display = "";
	document.getElementById('over').style.display = "";
}
			//
			// GamePanel オブジェクト（プロパティ）
			//
function GamePanel()
{
	this.timerID = -1;
	this.ct = 0;   // カウンター
	this.my = new My();   // 自機
	this.bs = new Boss();   // ボス
	this.no = 2;   // 敵機の数
	this.em = new Array();   // 敵機
	this.em[0] = new Enemy(0, this.bs);
	this.em[1] = new Enemy(1, this.bs);
					// 敵機の存在
	this.ex = new Array();
	if (mp.level == 1) {
		this.ex[0] = false;
		this.ex[1] = false;
	}
	else {
		this.ex[0] = true;
		this.ex[1] = true;
	}
	return this;
}
			//
			// GamePanel オブジェクト（メソッド timer）
			//
GamePanel.prototype.timer = function()
{
					// 描画
	gp.draw();
					// カウントアップ
	gp.ct = (gp.ct + 1) % 300;
}
			//
			// GamePanel オブジェクト（メソッド draw）
			//
GamePanel.prototype.draw = function()
{
					// キャンバスのクリア
	mp.ctx.clearRect(0, 0, mp.canvas.width, mp.canvas.height);
					// 描画
	mp.ctx.drawImage(gp.my.image, gp.my.x, gp.my.y);
	mp.ctx.drawImage(gp.bs.image, gp.bs.x, gp.bs.y);
	for (let i1 = 0; i1 < gp.no; i1++) {
		if (gp.ex[i1])
			mp.ctx.drawImage(gp.em[i1].image, gp.em[i1].x, gp.em[i1].y);
	}
}
			//
			// GamePanel オブジェクト（メソッド onKeyDown）
			//
GamePanel.prototype.onKeyDown = function(event)
{
	if (event.keyCode == 38)   // 「↑」キー
		gp.my.y -= gp.my.v;
	else if (event.keyCode == 40)   // 「↓」キー
		gp.my.y += gp.my.v;
	else if (event.keyCode == 37)   // 「←」キー
		gp.my.x -= gp.my.v;
	else if (event.keyCode == 39)   // 「→」キー
		gp.my.x += gp.my.v;
}
			//
			// My オブジェクト（プロパティ）
			//
function My()
{
	this.image = new Image();   // 自機の画像
	this.image.src = "image/my.gif";
	this.width = 50;   // 自機の幅
	this.height = 51;   // 自機の高さ
	this.x = mp.canvas.width / 2 - this.width / 2;   // 自機の位置(横)
	this.y = mp.canvas.height - this.height - 10;   // 自機の位置(縦)
	this.v = 20;   // 移動キーが押されたときの移動量
	return this;
}
			//
			// Boss オブジェクト（プロパティ）
			//
function Boss()
{
	this.image = new Image();   // ボス画像
	this.image.src = "image/boss.gif";
	this.width = 66;   // ボスの幅
	this.height = 95;   // ボスの高さ
	let a  = 100 + Math.floor((mp.canvas.width - 200 - this.width) * Math.random());
	this.x = a;   // ボスの位置(横)
	let b  = 10 + Math.floor(20 * Math.random());
	this.y = b;   // ボスの位置(縦)
	return this;
}
			//
			// Enemy オブジェクト（プロパティ）
			//
function Enemy(sw, bs)
{
	this.image = new Image();   // 敵機画像
	this.image.src = "image/enemy.gif";
	this.width = 27;   // 敵機の幅
	this.height = 41;   // 敵機の高さ
	this.x;   // 敵機の位置(横)
	this.y;   // 敵機の位置(縦)
					// 敵機の初期位置
	if (sw == 0) {
		this.x = bs.x - 150 + Math.floor(100 * Math.random());
		this.y = bs.y + bs.height - 80 + Math.floor(100 * Math.random());
	}
	else {
		this.x = bs.x + bs.width + 50 + Math.floor(100 * Math.random());
		this.y = bs.y + bs.height - 80 + Math.floor(100 * Math.random());
	}
	return this;
}
			//
			// GamePanel オブジェクト（メソッド next）
			//
GamePanel.prototype.next = function(sw)
{
	clearInterval(gp.timerID);   // タイマーの停止
	if (sw == 0)
		gcp_start();
	else
		gop_start();
}
