gp = null;   // GamePanel オブジェクト

			//
			// GamePanel の開始
			//
function gp_start()
{
					// GamePanel オブジェクト
	gp = new GamePanel();
					// タイマーのスタート
	gp.timerID = setInterval('gp.timer()', 10);
					// キーリスナの追加（キーが押された時）
	mp.canvas.addEventListener("keydown", gp.onKeyDown, false);
	mp.canvas.focus();
					// ボタンの表示制御
	document.getElementById('method').style.display = "none";
	document.getElementById('start').style.display = "none";
	document.getElementById('first').style.display = "none";
	document.getElementById('finish').style.display = "none";
	document.getElementById('clear').style.display = "";
	document.getElementById('over').style.display = "";
}
			//
			// GamePanel オブジェクト（プロパティ）
			//
function GamePanel()
{
	this.timerID = -1;
	this.ct = 0;   // カウンター
	this.my = new My();   // 自機
	this.bs = new Boss();   // ボス
	this.no = 2;   // 敵機の数
	this.em = new Array();   // 敵機
	this.em[0] = new Enemy(0, this.bs);
	this.em[1] = new Enemy(1, this.bs);
					// 敵機の存在
	this.ex = new Array();
	if (mp.level == 1) {
		this.ex[0] = false;
		this.ex[1] = false;
	}
	else {
		this.ex[0] = true;
		this.ex[1] = true;
	}
	return this;
}
			//
			// GamePanel オブジェクト（メソッド timer）
			//
GamePanel.prototype.timer = function()
{
					// 描画
	gp.draw();
					// 移動処理
	if (gp.ct%3 == 0)
		gp.my.bl.move();   // 自機の弾
	if (gp.ct%5 == 0)
		gp.bs.move();   // ボスの移動
					// カウントアップ
	gp.ct = (gp.ct + 1) % 300;
}
			//
			// GamePanel オブジェクト（メソッド draw）
			//
GamePanel.prototype.draw = function()
{
					// キャンバスのクリア
	mp.ctx.clearRect(0, 0, mp.canvas.width, mp.canvas.height);
					// 描画
							// 自機と弾
	mp.ctx.drawImage(gp.my.image, gp.my.x, gp.my.y);
	for (var i1 = 0; i1 < gp.my.bl.no; i1++) {
		if (gp.my.bl.ex[i1]) {
			mp.ctx.beginPath();
			mp.ctx.fillStyle = "rgb(0, 255, 0)";
			mp.ctx.arc(gp.my.bl.x[i1], gp.my.bl.y[i1], gp.my.bl.r, 0, 2*Math.PI);
			mp.ctx.fill();
		}
	}
							// ボス
	mp.ctx.drawImage(gp.bs.image, gp.bs.x, gp.bs.y);
							// 敵機
	for (let i1 = 0; i1 < gp.no; i1++) {
		if (gp.ex[i1])
			mp.ctx.drawImage(gp.em[i1].image, gp.em[i1].x, gp.em[i1].y);
	}
}
			//
			// GamePanel オブジェクト（メソッド onKeyDown）
			//
GamePanel.prototype.onKeyDown = function(event)
{
	if (event.keyCode == 38)   // 「↑」キー
		gp.my.y -= gp.my.v;
	else if (event.keyCode == 40)   // 「↓」キー
		gp.my.y += gp.my.v;
	else if (event.keyCode == 37)   // 「←」キー
		gp.my.x -= gp.my.v;
	else if (event.keyCode == 39)   // 「→」キー
		gp.my.x += gp.my.v;
	else if (event.keyCode == 32)   // 「スペース」キー
		gp.my.bl.shoot();
}
			//
			// My オブジェクト（プロパティ）
			//
function My()
{
	this.image = new Image();   // 自機の画像
	this.image.src = "image/my.gif";
	this.width = 50;   // 自機の幅
	this.height = 51;   // 自機の高さ
	this.x = mp.canvas.width / 2 - this.width / 2;   // 自機の位置(横)
	this.y = mp.canvas.height - this.height - 10;   // 自機の位置(縦)
	this.v = 20;   // 移動キーが押されたときの移動量
	this.bl = new Bullet();   // 弾
	return this;
}
			//
			// Bullet オブジェクト（プロパティ）
			//
function Bullet()
{
	this.r = 12;   // 弾の半径
	this.no = 15;   // 弾の全数
	this.no_1 = 5;   // 一度に撃てる弾数
	this.ct = 0;   // 現在の弾の数
	this.x = new Array();   // 弾の位置(横)
	this.y = new Array();   // 弾の位置(縦)
	this.v = 30;   // 弾の速さ
	this.fire = false;   // 弾を発射中か否か
	this.ex = new Array();   // 弾の存在
	for (let i1 = 0; i1 < this.no; i1++)
		this.ex[i1] = false;
}
			//
			// Bullet オブジェクト（メソッド move）
			//
Bullet.prototype.move = function()
{
					// 弾の移動
	for (let i1 = 0; i1 < gp.my.bl.no; i1++) {
		if (gp.my.bl.ex[i1]) {
			gp.my.bl.y[i1] -= gp.my.bl.v;
			if (gp.my.bl.y[i1] < -gp.my.bl.r)
				gp.my.bl.ex[i1] = false;
		}
	}
					// 次の弾の発射
	if (gp.my.bl.fire) {
		if (gp.my.bl.ct < gp.my.bl.no_1) {
			let sw = true;
			for (let i1 = 0; i1 < gp.my.bl.no && sw; i1++) {
				if (!gp.my.bl.ex[i1]) {
					gp.my.bl.x[i1]  = gp.my.x + gp.my.width / 2;
					gp.my.bl.y[i1]  = gp.my.y - gp.my.bl.r;
					gp.my.bl.ex[i1] = true;
					sw              = false;
				}
			}
			gp.my.bl.ct++;
			if (gp.my.bl.ct >= gp.my.bl.no_1) {
				gp.my.bl.fire = false;
				gp.my.bl.ct   = 0;
			}
		}
	}
}
			//
			// Bullet オブジェクト（メソッド shoot，最初の弾の発射）
			//
Bullet.prototype.shoot = function()
{
	if (!gp.my.bl.fire) {
		gp.my.bl.fire = true;
		gp.my.bl.ct   = 1;
		let sw = true;
		for (let i1 = 0; i1 < gp.my.bl.no && sw; i1++) {
			if (!gp.my.bl.ex[i1]) {
				gp.my.bl.x[i1]  = gp.my.x + gp.my.width / 2;
				gp.my.bl.y[i1]  = gp.my.y - gp.my.bl.r;
				gp.my.bl.ex[i1] = true;
				sw              = false;
			}
		}
	}
}
			//
			// Boss オブジェクト（プロパティ）
			//
function Boss()
{
	this.image = new Image();   // ボス画像
	this.image.src = "image/boss.gif";
	this.width = 66;   // ボスの幅
	this.height = 95;   // ボスの高さ
	let a  = 100 + Math.floor((mp.canvas.width - 200 - this.width) * Math.random());
	this.x = a;   // ボスの位置(横)
	let b  = 10 + Math.floor(20 * Math.random());
	this.y = b;   // ボスの位置(縦)
					// 行動パターンの設定
	this.ct = 1;
	this.ptn1 = new Array();
	this.ptn1[0] = new Array(-5, 0, 50);
	this.ptn1[1] = new Array(0, 20, 55);
	this.ptn1[2] = new Array(5, 0, 105);
	this.ptn1[3] = new Array(0, -20, 110);
	this.ptn2 = new Array();
	this.ptn2[0] = new Array(5, 0, 50);
	this.ptn2[1] = new Array(0, 20, 55);
	this.ptn2[2] = new Array(-5, 0, 105);
	this.ptn2[3] = new Array(0, -20, 110);
	this.ptn = new Array();
	if (this.x > mp.canvas.width/2-this.width/2)
		this.ptn = this.ptn1;
	else
		this.ptn = this.ptn2;
	return this;
}
			//
			// Boss オブジェクト（メソッド move）
			//
Boss.prototype.move = function()
{
					// 移動
	gp.bs.ct++;
	if (gp.bs.ct > 110)
		gp.bs.ct = 1;
					// ボスの位置
	let k = -1;
	for (let i1 = 0; i1 < gp.bs.ptn.length-1 && k < 0; i1++) {
		if (gp.bs.ct <= gp.bs.ptn[i1][2])
			k = i1;
	}
	if (k < 0)
		k = gp.bs.ptn.length - 1;
	gp.bs.x += gp.bs.ptn[k][0];
	gp.bs.y += gp.bs.ptn[k][1];
					// 敵機の位置
	if (gp.ex[0]) {
		gp.em[0].x += gp.bs.ptn[k][0];
		gp.em[0].y += gp.bs.ptn[k][1];
	}
	if (gp.ex[1]) {
		gp.em[1].x += gp.bs.ptn[k][0];
		gp.em[1].y += gp.bs.ptn[k][1];
	}
}
			//
			// Enemy オブジェクト（プロパティ）
			//
function Enemy(sw, bs)
{
	this.image = new Image();   // 敵機画像
	this.image.src = "image/enemy.gif";
	this.width = 27;   // 敵機の幅
	this.height = 41;   // 敵機の高さ
	this.x;   // 敵機の位置(横)
	this.y;   // 敵機の位置(縦)
					// 敵機の初期位置
	if (sw == 0) {
		this.x = bs.x - 150 + Math.floor(100 * Math.random());
		this.y = bs.y + bs.height - 80 + Math.floor(100 * Math.random());
	}
	else {
		this.x = bs.x + bs.width + 50 + Math.floor(100 * Math.random());
		this.y = bs.y + bs.height - 80 + Math.floor(100 * Math.random());
	}
	return this;
}
			//
			// GamePanel オブジェクト（メソッド next）
			//
GamePanel.prototype.next = function(sw)
{
	clearInterval(gp.timerID);   // タイマーの停止
	if (sw == 0)
		gcp_start();
	else
		gop_start();
}
